using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data;
using System.Globalization;
using System.Reflection;
using System.Text;
using System.Text.RegularExpressions;
using System.Transactions;
using Produmex.Foundation;
using Produmex.Foundation.Barcode;
using Produmex.Foundation.Collections;
using Produmex.Foundation.Data;
using Produmex.Foundation.Data.Sbo;
using Produmex.Foundation.Data.Sbo.BusinessObjects;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.Tables;
using Produmex.Foundation.Data.Sbo.DataObjects;
using Produmex.Foundation.Data.Sbo.Generators.BarcodeController;
using Produmex.Foundation.Data.SqlClient;
using Produmex.Foundation.Diagnostics;
using Produmex.Foundation.Messages;
using Produmex.Foundation.SlimScreen;
using Produmex.Foundation.SlimScreen.Interfaces.Definitions.DataObjects;
using Produmex.Foundation.SlimScreen.Interfaces.Definitions.KnownDataSets;
using Produmex.Foundation.SlimScreen.WinGui;
using Produmex.Foundation.Workflows;
using Produmex.Foundation.Workflows.Parameters;
using Produmex.Foundation.Wwf.Sbo.DataObjects;
using Produmex.Foundation.Wwf.Sbo.LocalServices;
using Produmex.Sbo.Logex.Data.BusinessObjects;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.Tables;
using Produmex.Sbo.Logex.Data.DataObjects;
using Produmex.Sbo.Logex.Data.Generators.SerialNumberController;
using Produmex.Sbo.Logex.Data.Providers;
using Produmex.Sbo.Logex.Novitan.BusinessObjects.Definitions;
using Produmex.Sbo.Logex.Novitan.Providers;



// PmxWorkflowExecutionTypes.SUB_FLOW
namespace Produmex.Sbo.Logex.WorkflowScripts
{
    /// <summary>
    /// Enter quantity
    /// </summary>
    public class WorkflowScript_EnterQuantityNovitanScript : WorkflowInstanceScriptBase
    {
        // * Input parameters *
        public ReadOnlyBinder<CultureInfo> DefaultCultureInfo;
        public ReadOnlyBinder<PmxOseCompany> PmxOseCompany;

        public ReadOnlyBinder<PmxItemInfo> ItemInfo;
        public ReadOnlyBinder<string> TitleKey;
        public ReadOnlyBinder<string> TitleKeyWeight;
        public ReadOnlyBinder<string> UOM;
        public ReadOnlyBinder<double> InitialQuantity;
        public ReadOnlyBinder<double> InnerQuantity;
        public ReadOnlyBinder<double> MaximumQuantity;
        public ReadOnlyBinder<int> NumberOfDigitsAfterDecimal;
        public ReadOnlyBinder<string> InnerUOM;
        public ReadOnlyBinder<string> MessageKeyBatchnumber;
        public ReadOnlyBinder<string> BatchNumber;
        public ReadOnlyBinder<DateTime?> BestBeforeDate;
        public ReadOnlyBinder<int?> ItriKey;
        public ReadOnlyBinder<string> SSCC;
        public ReadOnlyBinder<string> MessageKeySSCC;
        public ReadOnlyBinder<string> DocNum;
        public ReadOnlyBinder<double> StillToQuantity;
        public ReadOnlyBinder<string> MessageKeyStillQuantity;
        public ReadOnlyBinder<string> MessageKeyStillQuantityWeight;
        public ReadOnlyBinder<bool> AllowZero;
        public ReadOnlyBinder<string> LocationCode;
        public ReadOnlyBinder<double> TotalQuantityToPick;
        public ReadOnlyBinder<bool> UsePickingInfo;
        public ReadOnlyBinder<bool> IsAlternatePicking;
        public ReadOnlyBinder<double?> CurrentWeight;

        public ReadOnlyBinder<bool> AutoFillQuantityForPackagingTypes;
        public ReadOnlyBinder<bool> HidePickingLocation;


        //Serial number
        public ReadOnlyBinder<bool> ForceInputSerialNumbers;
        public ReadOnlyBinder<Collection<SerialNumberInfo>> ListOfSerialNumbersToUse;
		public ReadOnlyBinder<Collection<int>> ListOfLineNumbers;

		private Collection<SerialNumberInfo> currentListOfSerialNumbersToUse
        {
            get
            {
                return ListOfSerialNumbersToUse == null ? null : ListOfSerialNumbersToUse.Get();
            }
        }

		/// <summary>
		/// The list of serial numbers already entered
		/// This can be used when serial numbers are being scanned, and stored in memory.
		/// When a serial number is beging scanned from this list, the user will get an error message
		/// </summary>
		public ReadOnlyBinder<List<string>> ListOfSerialNumbersAlreadyEntered;

		private List<string> currentListOfSerialNumbersAlreadyEntered
        {
            get
            {
				return ListOfSerialNumbersAlreadyEntered == null ? null : ListOfSerialNumbersAlreadyEntered.Get();
            }
        }

       public ReadOnlyBinder<bool> HideSerialNumbersListToUse;

		private bool currentHideSerialNumbersListToUse
		{
			get
			{
				return HideSerialNumbersListToUse == null ? false : HideSerialNumbersListToUse.Get();
			}
		}


        public ReadOnlyBinder<int?> LineNum;
        private int? currentLineNum
        {
            get
            {
                return LineNum == null ? null : LineNum.Get();
            }
        }



        public ReadOnlyBinder<string> ObjectType;
        public ReadOnlyBinder<int?> DocEntry;
        public ReadOnlyBinder<bool> UseSerialNumberRange;
        public ReadOnlyBinder<double> MinimumQuantity;

        public ReadOnlyBinder<string> DestinationLocationCode;
        public ReadOnlyBinder<int?> LUID;

		//public ReadOnlyBinder<bool> UseTrack;
		public ReadOnlyBinder<string> SerialNumber;
		
		public ReadOnlyBinder<PmxVerifyType> TrackType;
		private PmxVerifyType currentTrackType {
			get {
				return TrackType.Get();
			}			
		}
		public ReadOnlyBinder<double?> CatchWeightPieces;
        //public ReadOnlyBinder<double?> MaximumQuantityUom2;
        public ReadOnlyBinder<bool> OverrideAskingWeight;

        public ReadOnlyBinder<BarcodeContainer> ScannedBarcodeContainer;

        public ReadOnlyBinder<double?> StillToQuantityUom2;

        public ReadOnlyBinder<bool> SetInitialQuantity;

		private bool currentSetInitialQuantity
		{
			get { return SetInitialQuantity == null ? false : SetInitialQuantity.Get(); }
		}

        private CultureInfo current_DefaultCultureInfo
        {
            get { return DefaultCultureInfo.Get(); }
        }

        private PmxOseCompany currentPmxOseCompany
        {
            get { return PmxOseCompany.Get(); }
        }

        private bool currentUsePickingInfo
        {
            get { return UsePickingInfo == null ? false : UsePickingInfo.Get(); }
        }
 
        private bool currentOverrideAskingWeight
        {
            get { return OverrideAskingWeight == null ? false : OverrideAskingWeight.Get(); }
        }

        private double? currentCatchWeightPieces
        {
            get { return CatchWeightPieces == null ? null : CatchWeightPieces.Get(); }
        }

        private double? currentStillToQuantityUom2
        {
            get { return StillToQuantityUom2 == null ? null : StillToQuantityUom2.Get(); }
        }

        private double? currentCurrentWeight
        {
            get { return CurrentWeight == null ? null : CurrentWeight.Get(); }
        }

        //private double? currentMaximumQuantityUom2
        //{
        //    get { return MaximumQuantityUom2 == null ? null : MaximumQuantityUom2.Get(); }
        //}

        private int? currentLUID
        {
            get { return LUID == null ? null : LUID.Get(); }
        }

        public ReadOnlyBinder<int?> BaseEntry;
        private int? currentBaseEntry
        {
            get { return BaseEntry == null ? null : BaseEntry.Get(); }
        }

        public ReadOnlyBinder<string> BaseType;
        private string currentBaseType
        {
            get { return BaseType == null ? null : BaseType.Get(); }
        }

        private string currentMessageKeyStillQuantityWeight
        {
            get { return MessageKeyStillQuantityWeight == null ? null : MessageKeyStillQuantityWeight.Get(); }
        }

        private BarcodeContainer currentScannedBarcodeContainer
        {
            get { return ScannedBarcodeContainer == null ? null : ScannedBarcodeContainer.Get(); }
        }

        /// <summary>
        /// Gets the current message key SSCC.
        /// </summary>
        /// <value>The current message key SSCC.</value>
        private string currentMessageKeySSCC
        {
            get { return MessageKeySSCC == null ? null : MessageKeySSCC.Get(); }
        }

        private bool currentAutoFillQuantityForPackagingTypes
        {
            get { return AutoFillQuantityForPackagingTypes == null ? false : AutoFillQuantityForPackagingTypes.Get(); }
        }

        private bool currentHidePickingLocation
        {
            get { return HidePickingLocation == null ? false : HidePickingLocation.Get(); }
        }

        private string currentDestinationLocationCode
        {
            get { return DestinationLocationCode == null ? null : DestinationLocationCode.Get(); }
        }

        private bool currentIsAlternatePicking
        {
            get { return IsAlternatePicking == null ? false : IsAlternatePicking.Get(); }
        }


        // * Output parameters *

        public ReadWriteBinder<bool> BackRequested;
        public ReadWriteBinder<double> QuantityEntered;
        public ReadWriteBinder<double?> QuantityUom2Entered;
        public ReadWriteBinder<Collection<string>> ListOfSerialNumbers;
		public ReadWriteBinder<PmxVerifyType> ReturnTrackType;


		public ReadOnlyBinder<List<KeyValuePair<double, double>>> WeightDetails;


        // Private fields
        private static readonly ILog s_log = LogProvider.GetLogger(MethodInfo.GetCurrentMethod().DeclaringType);

        ISboProviderService m_sboProviderService;


        #region Constructors

        public WorkflowScript_EnterQuantityNovitanScript(WorkflowInstanceBase parent, WorkflowInstanceFactory factory)
            : base(parent, factory)
        {
        }

        #endregion

        #region WorkflowInstanceScriptBase Members

        protected override void Execute()
        {
            // Parameters in scope
            Session session = GetScopeParameter("Session") as Session;
            m_sboProviderService = GetScopeParameter("<WwfService>ISboService") as ISboProviderService;

            string initialErrorKey = null;
            string deviceID = session.DeviceInstanceId;
            SboUserInfo userInfo = m_sboProviderService.GetCurrentUser();
            Message msg = null;
            string query = null;
            Collection<PackagingTypeInfo> listOfPackagingTypes = null;
            ProdumexError pmxError = null;
            object[] initialErrorParams = null;
			bool setFocusToQuantityControl = false;
			DataSet dsPackagingTypes = null;
            double currentQuantity = 0;
            double remainderOfMaximum = 0;
            double remainderOfStillToQty = 0;

			string currentSerialNumber = SerialNumber.Get();
			

			double initialQty = InitialQuantity.Get();

			if (currentSetInitialQuantity &&
				currentScannedBarcodeContainer != null &&
				currentScannedBarcodeContainer.GS1DataObject != null)
			{
				//Check if we got quantities
				if (currentScannedBarcodeContainer.GS1DataObject.Count.HasValue)
				{
					initialQty = currentScannedBarcodeContainer.GS1DataObject.Count.Value;
				}
				else
				{
					//allow for all items except 
					if (//temInfo.Get().BarcodeType == PmxBarcodeTypes.VariableGTIN &&
						!ItemInfo.Get().IsCatchWeightItem)
					{
						initialQty = BarcodeHelper.GetQuantityForMeasureType(ItemInfo.Get().UomGS1MeasureType, currentScannedBarcodeContainer, initialQty) ?? initialQty;
					}
				}
			}


            DataSet dsSerialNumber = null;
            Collection<int> currentListOfLineNumbers =null;

			if ( ListOfLineNumbers != null)
				currentListOfLineNumbers = ListOfLineNumbers.Get();

			

			IBarcodeController barcodeController = null;

            bool serialNumbersInUppercase = false;
			bool useTrack = false;
			bool isDefinedObjectType = !string.IsNullOrEmpty(ObjectType?.Get());

            Collection<string> listOfSerialNumbers = null;
            bool initialErrorKeyIsError = true;

            double numberOfNewNotLinkedSerialNumbersAllowed = 0;

            BackRequested.Set(false);

            double innerQuantity = 1;

            if (InnerQuantity.Get() != 0)
            {
                innerQuantity = InnerQuantity.Get();
            }

            double maxQtyForSerial = FormattingHelper.RoundSAPDecimal(MaximumQuantity.Get() * innerQuantity, 0);
            double maxInventoryQuantity = MaximumQuantity.Get() * innerQuantity;
            double stillToQuantityForSerial = FormattingHelper.RoundSAPDecimal(StillToQuantity.Get() * innerQuantity, 0);
            double stillToInventoryQuantity = StillToQuantity.Get() * innerQuantity;
            string uomForSerial = ItemInfo.Get().InventoryUom;
			PmxDictionary<string, SerialNumberWarnReply> warningsForSerialNumbers = null;
			ReturnTrackType.Set(currentTrackType);

			//CATCH WEIGHT
			bool askForPieces = false;
            bool askForWeight = false;
            PmxItemInfo itemInfo = ItemInfo.Get();
            string uomForPieces = null;
            string uomForWeight = null;
            int numberOfDecimalsForPieces = 0;
            int numberOfDecimalsForWeight = 0;
            double stillToQuantityForPieces = 0;
            double stillToQuantityForWeight = 0;
            double maxQuantityForPieces = -1;
            double maxQuantityForWeight = -1;

            double? quantityForPieces = null;
            double? quantityForWeight = null;

            double? autoQuantityForPieces = null;


            //END CATCH WEIGHT

            if (QuantityUom2Entered != null)
            {
                //Cleanup in case of non catch weight item, but Quantity uom2 still in memory
                QuantityUom2Entered.Set(null);
            }

            //set correct initial qty

            if (MaximumQuantity.Get() > 0 &&
                MaximumQuantity.Get() < initialQty)
            {
                initialQty = MaximumQuantity.Get();
            }


            int numberOfDecimalsForQuantityWithInnerQuantity = innerQuantity != 1 ? 6 : NumberOfDigitsAfterDecimal.Get();

            if (FormattingHelper.RoundSAPDecimal(MaximumQuantity.Get(), numberOfDecimalsForQuantityWithInnerQuantity) != MaximumQuantity.Get())
            {
                //something wrong with rounding of maximum qty
                //Example: Decimals = 2; Make reception of 0.5; set decimals = 0; Try to ad hoc move partial SSCC
                throw new ProdumexException(Produmex.Sbo.Logex.Data.ProdumexErrors.QuantityNotRoundedCorrectly(s_log, MaximumQuantity.Get(), ItemInfo.Get().UomDecimals, ItemInfo.Get().ItemCode));
            }

            if (MaximumQuantity.Get() == 0 && !AllowZero.Get())
            {
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                                        this.DefaultCultureInfo, BuildParamCollection(
                                        "MessageKey", "MSG_ERROR_MAXIMUM_QUANTITY_IS_ZERO",
                                        "ShowButton", true));
                msg = WaitForMessage();


                BackRequested.Set(true);
                return;
            }

            if ((ItemInfo.Get().HasSerialNumber || ItemInfo.Get().HasSAPSerialNumber) &&
                ForceInputSerialNumbers != null &&
                ForceInputSerialNumbers.Get())
            {
                goto Step_EnterSerialNumbersStart;
            }

		

            double minimum = -1;


        Step_CheckPackagingTypes:

            #region CHECK PACKAGING TYPE

            listOfPackagingTypes = new Collection<PackagingTypeInfo>();

            if (ItriKey.Get().HasValue)
            {

                m_sboProviderService.InvokeMethodWithDbConnection<object>(false, false, null, null,
                    delegate(PmxDbConnection conn, object[] parameters)
                    {
                        PmxItemAllConnectionsProvider prov = new PmxItemAllConnectionsProvider(conn);

                        listOfPackagingTypes = prov.GetTransactionalPackagingTypes(ItriKey.Get().Value, null, ItemInfo.Get().ItemCode);

                        return null;
                    });


            }

            if ((listOfPackagingTypes != null && listOfPackagingTypes.Count > 0) ||
                ItemInfo.Get().ListOfPackagingTypes.Count > 0)
            {
                //we need to enter the quantity by packagingtype
                goto Step_BuildListOfPackagingTypes;
            }
            else
            {
                if (itemInfo.IsCatchWeightItem)
                {
                    goto Step_CatchWeightEnterQuantity;
                }
                else
                {
                    goto Step_EnterDefaultQuantity;
                }
            }



            #endregion

        Step_EnterDefaultQuantity:

            #region ENTER DEFAULT QUANTITY

            if (!currentUsePickingInfo)
            {

                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IEnterQuantityWithItemInfoScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                    "InitialErrorKey", initialErrorKey,
                    "TitleKey", TitleKey.Get(),
                    "BarcodeController", barcodeController,
                    "ItemDescription", ItemInfo.Get().CustomItemDescription,
                    "ItemCode", ItemInfo.Get().ItemCode,
                    "ItemBarcode", ItemInfo.Get().CodeBars,
                    "InitialQuantity", initialQty,
                    "InnerQuantity", innerQuantity,
                    "MaximumQuantity", MaximumQuantity.Get(),
                    "NumberOfDigitsAfterDecimal", NumberOfDigitsAfterDecimal.Get(),
                    "InnerUOM", InnerUOM.Get(),
                    "UOM", UOM.Get(),
					"BarcodesAndUomQuantities", ItemInfo.Get().PurchaseBarcodesAndUomQuantities,
					"MessageKeyBatchnumber", MessageKeyBatchnumber == null ? null : MessageKeyBatchnumber.Get(),
                    "BatchNumber", BatchNumber.Get(),
                    "BestBeforeDate", BestBeforeDate.Get(),
                    "SSCC", SSCC.Get(),
                    "DocNum", DocNum.Get(),
                    "StillToQuantity", StillToQuantity.Get(),
                    "MessageKeyStillQuantity", MessageKeyStillQuantity.Get(),
                    "AllowZero", AllowZero.Get(),
                    "MessageKeySSCC", currentMessageKeySSCC,
				    //"GS1WeightAI", itemInfo.BarcodeType == PmxBarcodeTypes.VariableGTIN ? itemInfo.UomGS1MeasureType : 0
				  	"GS1WeightAI", itemInfo.UomGS1MeasureType

					));
            }
            else
            {

				session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.Picking.IEnterQuantityWithPickingInfoScreen),
					DefaultCultureInfo.Get(), BuildParamCollection(
					"InitialErrorKey", initialErrorKey,
					"TitleKey", TitleKey.Get(),
					"BarcodeController", barcodeController,
					"ItemDescription", ItemInfo.Get().CustomItemDescription,
					"ItemCode", ItemInfo.Get().ItemCode,
					"ItemBarcode", ItemInfo.Get().CodeBars,
					"InitialQuantity", initialQty,
					"InnerQuantity", innerQuantity,
					"MaximumQuantity", MaximumQuantity.Get(),
					"NumberOfDigitsAfterDecimal", NumberOfDigitsAfterDecimal.Get(),
					"InnerUOM", InnerUOM.Get(),
					"UOM", UOM.Get(),
					"BarcodesAndUomQuantities", ItemInfo.Get().SalesBarcodesAndUomQuantities,
					"BatchNumber", BatchNumber.Get(),
					"BestBeforeDate", BestBeforeDate.Get(),
					"SSCC", SSCC.Get(),
					"IsAlternate", currentIsAlternatePicking,
					"DocNum", DocNum.Get(),
					"StillToPick", StillToQuantity.Get(),
					"MessageKeyStillQuantity", MessageKeyStillQuantity.Get(),
					"AllowZero", AllowZero.Get(),
					"TotalQuantityToPick", TotalQuantityToPick.Get(),
					"LocationCode", LocationCode.Get(),
					"HidePickingLocation", currentHidePickingLocation,
					"ImagePath", ItemInfo.Get().PictureName,
					"MessageKeyBatchnumber", MessageKeyBatchnumber == null ? null : MessageKeyBatchnumber.Get(),
					//"GS1WeightAI", itemInfo.BarcodeType == PmxBarcodeTypes.VariableGTIN ? itemInfo.UomGS1MeasureType : 0
					"GS1WeightAI", itemInfo.UomGS1MeasureType

					));
            }




            msg = WaitForMessage();

            // reset error
            initialErrorKey = null;

            if (msg.Name.EndsWith(".QuantityEntered"))
            {
                QuantityEntered.Set(ExtractParameter<double>(msg.Parameters, "quantity"));

                return;
            }
            else if (msg.Name.EndsWith(".BackRequested"))
            {
                BackRequested.Set(true);
                return;
            }


            #endregion

        Step_BuildListOfPackagingTypes:

            #region BUILD LIST OF PACKAGING TYPES


            if (listOfPackagingTypes == null || listOfPackagingTypes.Count == 0)
            {
				string defaultUom = itemInfo.InventoryUom;

				switch (ObjectType.Get())
				{
					case Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxObjectTypes.PmxPickList:
					case SboObjectTypes.SalesReturn:
						defaultUom = itemInfo.SalesUom;
						break;
					case SboObjectTypes.PurchaseReturn:
					case SboObjectTypes.PurchaseOrder:
						defaultUom = itemInfo.PurchaseUom;
						break;
				}

				listOfPackagingTypes = new Collection<PackagingTypeInfo>();
                //there is no batch, but the item has a list of packaging types.
                //we need to build the list backwards, because we need last packaging type first
                for (int iLoop = (ItemInfo.Get().ListOfPackagingTypes.Count - 1); iLoop >= 0; iLoop--)
                {
                    PackagingTypeInfo info = new PackagingTypeInfo();

                    info.Barcode = ItemInfo.Get().ListOfPackagingTypes[iLoop].Barcodes;
                    info.PackagingTypeCode = ItemInfo.Get().ListOfPackagingTypes[iLoop].PackagingTypeCode;
                    info.PackagingTypeName = ItemInfo.Get().ListOfPackagingTypes[iLoop].PackagingTypeName;
                    info.QuantityPerPack = ItemInfo.Get().ListOfPackagingTypes[iLoop].Quantity;
                    info.HideDuringEnteringQuantity = ItemInfo.Get().ListOfPackagingTypes[iLoop].HideDuringEnteringQuantity;

					if (defaultUom == info.PackagingTypeCode)
					{
						initialQty *= info.QuantityPerPack;
					}

                    listOfPackagingTypes.Add(info);
                }
            }

            //add one last packaging type for the uom
            PackagingTypeInfo uomInfo = new PackagingTypeInfo();

            uomInfo.Barcode.Add(ItemInfo.Get().CodeBars);
            uomInfo.PackagingTypeCode = ItemInfo.Get().InventoryUom;
            uomInfo.PackagingTypeName = ItemInfo.Get().InventoryUom;
            uomInfo.QuantityPerPack = 1;
            uomInfo.NumberOfDecimals = ItemInfo.Get().UomDecimals;

            listOfPackagingTypes.Add(uomInfo);

            currentQuantity = 0;
            remainderOfMaximum = MaximumQuantity.Get();
            remainderOfStillToQty = StillToQuantity.Get();


            //For catch weight items, first check if pieces needs to be asked
            if (ItemInfo.Get().IsCatchWeightItem)
            {
                goto Step_CatchWeightEnterQuantity;
            }



            goto Step_EnterQuantityByPackagingType;

            #endregion

        Step_EnterQuantityByPackagingType:

            #region ENTER QUANTITY BY PACKAGING TYPE

            int counter = 0;
            bool goBack = false;

			string gtin = BarcodeHelper.GetProductIdentification(currentScannedBarcodeContainer);

			double extraInitialQuantityforEA = 0.0;

			while (true)
            {
				double initialQtyPackType = initialQty;

				string innerUOM = null;
				double innerQty = 1;

				//calculate max quantity
				remainderOfMaximum = FormattingHelper.RoundSAPDecimal(MaximumQuantity.Get() * innerQuantity, NumberOfDigitsAfterDecimal.Get());
				remainderOfStillToQty = FormattingHelper.RoundSAPDecimal(StillToQuantity.Get() * innerQuantity, NumberOfDigitsAfterDecimal.Get());

				foreach (PackagingTypeInfo info in listOfPackagingTypes)
				{
					if (info.Quantity != 0)
					{
						double qtyToReduce = FormattingHelper.RoundSAPDecimal(info.Quantity * FormattingHelper.RoundSAPDecimal(info.QuantityPerPack, NumberOfDigitsAfterDecimal.Get()), NumberOfDigitsAfterDecimal.Get());
						if (counter >= listOfPackagingTypes.Count - 1)
						{
							qtyToReduce -= extraInitialQuantityforEA;
						}

						remainderOfMaximum -= qtyToReduce;
						remainderOfStillToQty -= qtyToReduce;

						initialQtyPackType -= info.Quantity * info.QuantityPerPack;
					}
				}

				if (counter < listOfPackagingTypes.Count - 1 && listOfPackagingTypes[counter].Barcode.Contains(gtin))
				{
					if (listOfPackagingTypes[counter].HideDuringEnteringQuantity)
					{
						listOfPackagingTypes[counter].Quantity = 0;

						listOfPackagingTypes[listOfPackagingTypes.Count - 1].Quantity += listOfPackagingTypes[counter].QuantityPerPack;

						extraInitialQuantityforEA += listOfPackagingTypes[counter].QuantityPerPack;
					}
					else
					{
						listOfPackagingTypes[counter].Quantity += 1;
					}

					initialQtyPackType += listOfPackagingTypes[counter].QuantityPerPack;
				}

				int step = 1;
				while (listOfPackagingTypes.Count > counter + step && listOfPackagingTypes[counter + step].HideDuringEnteringQuantity)
				{
					++step;
				}

				if (listOfPackagingTypes.Count > counter + step)
				{
					innerUOM = listOfPackagingTypes[counter + step].PackagingTypeName;
					innerQty = FormattingHelper.RoundSAPDecimal(listOfPackagingTypes[counter].QuantityPerPack / listOfPackagingTypes[counter + step].QuantityPerPack, NumberOfDigitsAfterDecimal.Get());
				}

				double currentMaxQuantity = FormattingHelper.FloorForDecimals(remainderOfMaximum / FormattingHelper.RoundSAPDecimal(listOfPackagingTypes[counter].QuantityPerPack, NumberOfDigitsAfterDecimal.Get()), NumberOfDigitsAfterDecimal.Get());
				double currentStillTo = FormattingHelper.FloorForDecimals(remainderOfStillToQty / FormattingHelper.RoundSAPDecimal(listOfPackagingTypes[counter].QuantityPerPack, NumberOfDigitsAfterDecimal.Get()), NumberOfDigitsAfterDecimal.Get());

				if (listOfPackagingTypes[counter].NumberOfDecimals == 0)
                {
                    currentMaxQuantity = Math.Floor(currentMaxQuantity);
                }

                if (currentAutoFillQuantityForPackagingTypes)
                {
                    listOfPackagingTypes[counter].InitialQuantity = Math.Max(0, FormattingHelper.FloorForDecimals(currentStillTo, listOfPackagingTypes[counter].NumberOfDecimals));
                }
                else
                {
                    listOfPackagingTypes[counter].InitialQuantity = Math.Max(0, FormattingHelper.FloorForDecimals(initialQtyPackType / listOfPackagingTypes[counter].QuantityPerPack, listOfPackagingTypes[counter].NumberOfDecimals));
                }

				if (counter == listOfPackagingTypes.Count - 1)
				{
					listOfPackagingTypes[counter].InitialQuantity += extraInitialQuantityforEA;
				}


				if (((MaximumQuantity.Get() * innerQuantity) > 0 && currentMaxQuantity <= 0) ||
                    listOfPackagingTypes[counter].HideDuringEnteringQuantity)
                {
                    if (!goBack)
                    {
                        //current packaging type contains too much items to pick
                        counter++;
                    }
                    else
                    {
                        //We go back, but previous pack type has too much items, we go back one more step
                        counter--;
                    }
                }
                else
                {
                    if (!currentUsePickingInfo)
                    {
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IEnterQuantityWithItemInfoScreen),
                             DefaultCultureInfo.Get(), BuildParamCollection(
                             "InitialErrorKey", initialErrorKey,
                             "TitleKey", TitleKey.Get(),
                             "BarcodeController", barcodeController,
                             "ItemDescription", ItemInfo.Get().CustomItemDescription,
                             "ItemCode", ItemInfo.Get().ItemCode,
                             "ItemBarcode", listOfPackagingTypes[counter].Barcode.Count > 0 ? listOfPackagingTypes[counter].Barcode[0] : null, //ItemInfo.Get().CodeBars,
                             "InitialQuantity", listOfPackagingTypes[counter].InitialQuantity,
                             "InnerQuantity", innerQty,
                             "MaximumQuantity", currentMaxQuantity,
                             "NumberOfDigitsAfterDecimal", listOfPackagingTypes[counter].NumberOfDecimals,
                             "InnerUOM", innerUOM,
                             "UOM", listOfPackagingTypes[counter].PackagingTypeName,
							 "BarcodesAndUomQuantities", ItemInfo.Get().PurchaseBarcodesAndUomQuantities,
							 "BatchNumber", BatchNumber.Get(),
                             "BestBeforeDate", BestBeforeDate.Get(),
                             "SSCC", SSCC.Get(),
                             "DocNum", DocNum.Get(),
                             "StillToQuantity", currentStillTo,
                             "MessageKeyStillQuantity", MessageKeyStillQuantity.Get(),
                             "AllowZero", true,
                             "MessageKeySSCC", currentMessageKeySSCC,
                             "MessageKeyBatchnumber", MessageKeyBatchnumber == null ? null : MessageKeyBatchnumber.Get(),
							 "SetFocusToQuantityControl", setFocusToQuantityControl
                             ));

                    }
                    else
                    {
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.Picking.IEnterQuantityWithPickingInfoScreen),
                           DefaultCultureInfo.Get(), BuildParamCollection(
                           "InitialErrorKey", initialErrorKey,
                           "TitleKey", TitleKey.Get(),
                           "BarcodeController", barcodeController,
                           "ItemDescription", ItemInfo.Get().CustomItemDescription,
                           "ItemCode", ItemInfo.Get().ItemCode,
                           "ItemBarcode", listOfPackagingTypes[counter].Barcode.Count > 0 ? listOfPackagingTypes[counter].Barcode[0] : null,//ItemInfo.Get().CodeBars,
                           "InitialQuantity", listOfPackagingTypes[counter].InitialQuantity,
                           "InnerQuantity", innerQty,
                           "MaximumQuantity", currentMaxQuantity,
                           "NumberOfDigitsAfterDecimal", listOfPackagingTypes[counter].NumberOfDecimals,
                           "InnerUOM", innerUOM,
                           "UOM", listOfPackagingTypes[counter].PackagingTypeName,
						   "BarcodesAndUomQuantities", ItemInfo.Get().SalesBarcodesAndUomQuantities,
						   "BatchNumber", BatchNumber.Get(),
                           "BestBeforeDate", BestBeforeDate.Get(),
                           "SSCC", SSCC.Get(),
                           "IsAlternate", currentIsAlternatePicking,
                           "DocNum", DocNum.Get(),
                           "StillToPick", currentStillTo,
                           "MessageKeyStillQuantity", MessageKeyStillQuantity.Get(),
                           "AllowZero", true,
                           "TotalQuantityToPick", TotalQuantityToPick.Get(),
                           "LocationCode", LocationCode.Get(),
                           "HidePickingLocation", currentHidePickingLocation,
                           "ImagePath", ItemInfo.Get().PictureName,
                           "MessageKeyBatchnumber", MessageKeyBatchnumber == null ? null : MessageKeyBatchnumber.Get()
                           ));
                    }




                    msg = WaitForMessage();

                    // reset error
                    initialErrorKey = null;

                    if (msg.Name.EndsWith(".QuantityEntered"))
                    {
                        listOfPackagingTypes[counter].Quantity = ExtractParameter<double>(msg.Parameters, "quantity");

                        counter++;
                        goBack = false;
                    }
                    else if (msg.Name.EndsWith(".BackRequested"))
                    {
						listOfPackagingTypes[counter].Quantity = 0;
						counter--;
						if (counter >= 0)
						{
							listOfPackagingTypes[counter].Quantity = 0;
						}
						goBack = true;
                    }
                }

                if (counter < 0)
                {
                    BackRequested.Set(true);
                    return;
                }

                if (counter >= listOfPackagingTypes.Count)
                {
                    double tempQuantity = 0;

                    foreach (PackagingTypeInfo info in listOfPackagingTypes)
                    {
                        tempQuantity += (info.Quantity * info.QuantityPerPack);
                    }

                    if (tempQuantity == 0 &&
                        !AllowZero.Get())
                    {
                        initialErrorKey = "MSG_ERROR_ZERO_QUANTITY_NOT_ALLOWED";
                        counter--;
                    }
                    else
                    {
                        break;
                    }
                }
            }


            if (ItemInfo.Get().IsCatchWeightItem)
            {
                goto Step_AfterEnterQuantityByPackagingTypeCatchWeight;
            }


            goto Step_SendQuantity;



            #endregion

        Step_EnterSerialNumbersStart:

            #region ENTER SERIAL NUMBERS START

            maxQtyForSerial = FormattingHelper.RoundSAPDecimal(MaximumQuantity.Get() * innerQuantity, 0);
			warningsForSerialNumbers = null;

            //Initialize data
            listOfSerialNumbers = new Collection<string>();
            dsSerialNumber = GetNewSerialNumberDataSet();



            barcodeController = this.ExecuteMethodWithDbConnection<IBarcodeController>(out pmxError, false, false,
             delegate(PmxDbConnection conn, object[] parameters)
             {
                 PmxBarcodeProvider bcProv = new PmxBarcodeProvider(conn);
                 PmxSerialNumberProvider senuProv = new PmxSerialNumberProvider(conn);

                 serialNumbersInUppercase = senuProv.AllwaysEnterInUppercase();

                 return bcProv.GetBarcodeController();


             });


            if (currentLineNum.HasValue)
            {
				if (currentListOfLineNumbers == null)
				{
					currentListOfLineNumbers = new Collection<int>();
				}
				if(!currentListOfLineNumbers.Contains(currentLineNum.Value))
				{
					currentListOfLineNumbers.Add(currentLineNum.Value);
				}
            }


            numberOfNewNotLinkedSerialNumbersAllowed = maxQtyForSerial;

            if (currentListOfSerialNumbersToUse != null &&
                currentListOfSerialNumbersToUse.Count > 0)
            {
                numberOfNewNotLinkedSerialNumbersAllowed -= currentListOfSerialNumbersToUse.Count;

				if (!currentHideSerialNumbersListToUse)
				{

					DataSet dsLinkedSerialNumbers = GetNewLinkedSerialNumberDataSet(currentListOfSerialNumbersToUse, dsSerialNumber);

					//show all linked serial numbers

					session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IIdentifyMultipleSerialNumberScreen),
					DefaultCultureInfo.Get(), BuildParamCollection(
						"InitialErrorKey", initialErrorKey,
						"InitialErrorParams", initialErrorParams,
						"InitialErrorKeyIsError", initialErrorKeyIsError,
						"TitleKey", "MSG_TITLE_LINKED_SERIAL_NUMBER",
						"BarcodeController", barcodeController,
						"SerialNumberDS", dsLinkedSerialNumbers,
						"ItemDescription", ItemInfo.Get().CustomItemDescription,
						"ItemCode", ItemInfo.Get().ItemCode,
						"ItemBarcode", ItemInfo.Get().CodeBars,
						"UOM", uomForSerial,
						"BatchNumber", BatchNumber.Get(),
						"BestBeforeDate", BestBeforeDate.Get(),
						"SSCC", SSCC.Get(),
						"DocNum", DocNum.Get(),
						"StillToQuantity", stillToQuantityForSerial,
						"MessageKeyStillQuantity", MessageKeyStillQuantity.Get(),
						"UseSerialNumberRange", false,
						"OnlyShowList", true,
						"UseUppercase", serialNumbersInUppercase
						));
					msg = WaitForMessage();

					if (msg.Name.EndsWith(".BackRequested"))
					{
						//Go back
						BackRequested.Set(true);
						return;
					}
				}

            }

            #endregion

        Step_EnterSerialNumber:

            #region ENTER SERIAL NUMBER

            bool useRange = false;
			warningsForSerialNumbers = null;

            if (this.UseSerialNumberRange != null)
            {
                useRange = UseSerialNumberRange.Get();
            }

			if (this.GetNumberOfRows(dsSerialNumber) == 0 && !string.IsNullOrEmpty(currentSerialNumber))
			{

				//Is serial number allowed?
				Collection<string> tempFullListOfSerialNumbers = new Collection<string>();
				foreach (DataRow row in dsSerialNumber.Tables[0].Rows)
				{
					//add to list
					tempFullListOfSerialNumbers.Add(Convert.ToString(row[SerialNumberDataSet.Columns.SERIALNUMBER.Name]));
				}
				tempFullListOfSerialNumbers.Add(currentSerialNumber);

				if (ReturnTrackType.Get() == PmxVerifyType.One || ReturnTrackType.Get() == PmxVerifyType.All)
				{
					useTrack = true;
				}
				else useTrack = false;		
				
			
				//Pass full list, otherwise we cannot correctly know if new serial numbers ara allowed.
				pmxError = ValidateSerialNumbers(currentSerialNumber, LocationCode.Get(), currentDestinationLocationCode, currentListOfLineNumbers, ItemInfo.Get().ItemCode, tempFullListOfSerialNumbers, ref warningsForSerialNumbers, useTrack);


				if (pmxError != null)
				{
					session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
						this.DefaultCultureInfo, BuildParamCollection(
						"PmxError", pmxError,
						"ShowButton", true));
					msg = WaitForMessage();

					//retry?
					//ask user if he wants to retry
					session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
						DefaultCultureInfo.Get(), BuildParamCollection(
							"TitleKey", "MSG_TITLE_RETRY_UPDATE",
							"MessageKey", "MSG_QUESTION_AN_ERROR_OCCURED_WANT_RETRY"));
					msg = WaitForMessage();

					if (msg.Name.ToLower().EndsWith(".yes"))
					{
						goto Step_EnterSerialNumber;
					}

					switch (ReturnTrackType.Get())
					{
						case PmxVerifyType.One:
							ReturnTrackType.Set(PmxVerifyType.None);
							break;
						case PmxVerifyType.All:
							currentSerialNumber = "";
							break;
						default:
							break;
					}
				}

				
				DataRow rowToAdd = dsSerialNumber.Tables[0].NewRow();
				rowToAdd[SerialNumberDataSet.Columns.SERIALNUMBER.Name] = currentSerialNumber;
				dsSerialNumber.Tables[0].Rows.InsertAt(rowToAdd, 0);

				switch (ReturnTrackType.Get())
				{
					case PmxVerifyType.One:
						ReturnTrackType.Set(PmxVerifyType.None);
						break;
					case PmxVerifyType.All:
						break;
					default:
						break;
				}


			}



			session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IIdentifyMultipleSerialNumberScreen),
                DefaultCultureInfo.Get(), BuildParamCollection(
                    "InitialErrorKey", initialErrorKey,
                    "InitialErrorParams", initialErrorParams,
                    "InitialErrorKeyIsError", initialErrorKeyIsError,
                    "TitleKey", "MSG_TITLE_IDENTIFY_SERIAL_NUMBER",
                    "BarcodeController", barcodeController,
                    "SerialNumberDS", dsSerialNumber,
                    "ItemDescription", ItemInfo.Get().CustomItemDescription,
                    "ItemCode", ItemInfo.Get().ItemCode,
                    "ItemBarcode", ItemInfo.Get().CodeBars,
                    "UOM", uomForSerial,
                    "BatchNumber", BatchNumber.Get(),
                    "BestBeforeDate", BestBeforeDate.Get(),
                    "SSCC", SSCC.Get(),
                    "DocNum", DocNum.Get(),
                    "StillToQuantity", stillToQuantityForSerial,
                    "MessageKeyStillQuantity", MessageKeyStillQuantity.Get(),
                    "UseSerialNumberRange", useRange,
					"ShowListButton", (currentListOfSerialNumbersToUse != null && currentListOfSerialNumbersToUse.Count > 0 && !currentHideSerialNumbersListToUse),
                    "UseUppercase", serialNumbersInUppercase,
                    "MessageKeyBatchnumber", MessageKeyBatchnumber == null ? null : MessageKeyBatchnumber.Get()

                            ));
            msg = WaitForMessage();
			
            //clear the error
            initialErrorKey = null;
            initialErrorKeyIsError = true;
            initialErrorParams = null;

            if (msg.Name.EndsWith(".BackRequested"))
            {
                if (currentListOfSerialNumbersToUse != null &&
                currentListOfSerialNumbersToUse.Count > 0 &&
					!currentHideSerialNumbersListToUse)
                {
                    goto Step_ShowSerialList;
                }
                else
                {
                    BackRequested.Set(true);
                    return;
                }
            }
            if (msg.Name.EndsWith(".ShowList"))
            {
                goto Step_ShowSerialList;
            }
            if (msg.Name.EndsWith(".SerialNumberScanned"))
			{
				#region SERIAL NUMBER SCANNED

				if (maxQtyForSerial > 0 &&
                    Convert.ToDouble(this.GetNumberOfRows(dsSerialNumber)) >= maxQtyForSerial)
                {
                    //maximum serial numbers entered, so send error
                    initialErrorKey = "MSG_ERROR_NO_MORE_SERIAL_NUMBER_NEEDED";
                    goto Step_EnterSerialNumber;
                }

                string serialNumber = ExtractParameter<string>(msg.Parameters, "serialNumber");

                //parse through controller
                if (barcodeController != null)
                {
                    BarcodeContainer bc = ExtractParameter<BarcodeContainer>(msg.Parameters, "barcodeContainer");
                    //try
                    //{
                    //    bc = barcodeController.GetSerialNumber(serialNumber, null);
                    //}
                    //catch (Exception ex)
                    //{
                    //    s_log.Error("Barcode GetSerialNumber() ", ex);
                    //    initialErrorKey = "MSG_ERROR_INCORRECT_BARCODE";
                    //    initialErrorKeyIsError = true;
                    //    goto Step_EnterSerialNumber;
                    //}
                    if (!string.IsNullOrEmpty(bc.SerialNumber))
                    {
                        serialNumber = bc.SerialNumber;

                        //check if correct data was scanned
                        if (!string.IsNullOrEmpty(bc.ItemCode) &&
                            bc.ItemCode != ItemInfo.Get().ItemCode)
                        {
                            //incorrect item
                            initialErrorParams = new object[3] { serialNumber, ItemInfo.Get().ItemCode, bc.ItemCode };
                            initialErrorKey = "MSG_ERROR_SERIAL_NUMBER_NOT_MATCHES_NEEDED_ITEM";
                            goto Step_EnterSerialNumber;
                        }

                        if (bc.GS1DataObject != null &&
                            !string.IsNullOrEmpty(bc.GS1DataObject.LotNumber) &&
                           bc.GS1DataObject.LotNumber != BatchNumber.Get())
                        {
                            //incorrect item
                            initialErrorParams = new object[3] { serialNumber, BatchNumber.Get(), bc.GS1DataObject.LotNumber };
                            initialErrorKey = "MSG_ERROR_SERIAL_NUMBER_NOT_MATCHES_NEEDED_BATCH";
                            goto Step_EnterSerialNumber;
                        }

                    }



                }

                // ADD CHECK ON SERIAL NUMBER FORMAT 
                string serialFormat = ItemInfo.Get().SerialNumberFormat;

                if (!string.IsNullOrEmpty(serialFormat))
                {
                    if (!SerialNumberMatchesFormat(serialNumber, serialFormat))
                    {
                        initialErrorParams = new object[3] { serialNumber, ItemInfo.Get().ItemCode, serialFormat };
                        initialErrorKey = "MSG_ERROR_SERIAL_NUMBER_NOT_MATCHES_FORMAT";
                        goto Step_EnterSerialNumber;
                    }
                }

				if(currentListOfSerialNumbersAlreadyEntered!= null &&
					currentListOfSerialNumbersAlreadyEntered.Count > 0 &&
					currentListOfSerialNumbersAlreadyEntered.Contains(serialNumber))
				{
					initialErrorKey = "MSG_ERROR_SERIAL_NUMBER_NOT_ALLOWED";
					goto Step_EnterSerialNumber;
				}

                DataRow[] rows = dsSerialNumber.Tables[0].Select(string.Format("{0} = '{1}'", SerialNumberDataSet.Columns.SERIALNUMBER.Name, serialNumber));
                if (rows.Length > 0)
                {
                    initialErrorKey = "MSG_ERROR_SERIAL_NUMBER_ALREADY_SCANNED";
                }
                else
                {
                    bool foundSerialNumberInLinkedSerialNumbers = false;
                    if (currentListOfSerialNumbersToUse != null)
                    {

                        //check if it is valid by serial numbers to use
                        foreach (SerialNumberInfo serInfo in currentListOfSerialNumbersToUse)
                        {
                            if (serInfo.SerialNumber == serialNumber)
                            {
                                //we found serial number
                                foundSerialNumberInLinkedSerialNumbers = true;
                            }
                        }


                        if (!foundSerialNumberInLinkedSerialNumbers &&
                            numberOfNewNotLinkedSerialNumbersAllowed < 1)
                        {
                            //serial number is not linked, and no new serial numbers are allowed
                            initialErrorKey = "MSG_ERROR_NEW_SERIAL_NUMBER_CREATION_NOT_ALLOWED";

                            if (currentListOfSerialNumbersToUse != null &&
                                currentListOfSerialNumbersToUse.Count > 0 &&
								!currentHideSerialNumbersListToUse)
                            {
                                DataSet dsLinkedSerialNumbers = GetNewLinkedSerialNumberDataSet(currentListOfSerialNumbersToUse, dsSerialNumber);

                                //show all linked serial numbers

                                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IIdentifyMultipleSerialNumberScreen),
                                DefaultCultureInfo.Get(), BuildParamCollection(
                                    "InitialErrorKey", initialErrorKey,
                                    "InitialErrorParams", initialErrorParams,
                                    "InitialErrorKeyIsError", initialErrorKeyIsError,
                                    "TitleKey", "MSG_TITLE_LINKED_SERIAL_NUMBER",
                                    "BarcodeController", barcodeController,
                                    "SerialNumberDS", dsLinkedSerialNumbers,
                                    "ItemDescription", ItemInfo.Get().CustomItemDescription,
                                    "ItemCode", ItemInfo.Get().ItemCode,
                                    "ItemBarcode", ItemInfo.Get().CodeBars,
                                    "UOM", uomForSerial,
                                    "BatchNumber", BatchNumber.Get(),
                                    "BestBeforeDate", BestBeforeDate.Get(),
                                    "SSCC", SSCC.Get(),
                                    "DocNum", DocNum.Get(),
                                    "StillToQuantity", stillToQuantityForSerial,
                                    "MessageKeyStillQuantity", MessageKeyStillQuantity.Get(),
                                    "UseSerialNumberRange", false,
                                    "OnlyShowList", true,
                                    "UseUppercase", serialNumbersInUppercase,
                                    "MessageKeyBatchnumber", MessageKeyBatchnumber == null ? null : MessageKeyBatchnumber.Get()
                                    ));
                                msg = WaitForMessage();

                                initialErrorKey = null;
                            }


                            goto Step_EnterSerialNumber;
                        }

                    }



					warningsForSerialNumbers = null;


                    if (isDefinedObjectType)
                    {
                        //Is serial number allowed?
						Collection<string> tempFullListOfSerialNumbers = new Collection<string>();
						foreach (DataRow row in dsSerialNumber.Tables[0].Rows)
						{
							//add to list
							tempFullListOfSerialNumbers.Add(Convert.ToString(row[SerialNumberDataSet.Columns.SERIALNUMBER.Name]));
						}
						tempFullListOfSerialNumbers.Add(serialNumber);

						//Pass full list, otherwise we cannot correctly know if new serial numbers ara allowed.


						if (ReturnTrackType.Get() == PmxVerifyType.One || ReturnTrackType.Get() == PmxVerifyType.All)
						{
							useTrack = true;
						}
						else useTrack = false;

						pmxError = ValidateSerialNumbers(serialNumber, LocationCode.Get(), currentDestinationLocationCode, currentListOfLineNumbers, ItemInfo.Get().ItemCode, tempFullListOfSerialNumbers, ref warningsForSerialNumbers, useTrack);


                        if (pmxError != null)
                        {
                            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                                this.DefaultCultureInfo, BuildParamCollection(
                                "PmxError", pmxError,
                                "ShowButton", true));
                            msg = WaitForMessage();

                            goto Step_EnterSerialNumber;
                        }

						switch (ReturnTrackType.Get())
						{
							case PmxVerifyType.One:
								ReturnTrackType.Set(PmxVerifyType.None);
								break;
							case PmxVerifyType.All:
								break;
							default:
								break;
						}


					}

					if (warningsForSerialNumbers != null &&
						warningsForSerialNumbers.Count > 0)
					{
						//User needs to confirm serial numbers
						foreach (string warnSerialNumber in warningsForSerialNumbers.Keys)
						{
							session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
								DefaultCultureInfo.Get(), BuildParamCollection(
									"TitleKey", "MSG_TITLE_CONFIRM_SERIAL_NUMBER_WARNING",
									"MessageKey", warningsForSerialNumbers[warnSerialNumber].MessageKey,
									"Parameters", warningsForSerialNumbers[warnSerialNumber].MessageParams
									));
							msg = WaitForMessage();

							if (msg.Name.EndsWith(".No"))
							{
								//Serial number not confirmed, so do not use it
								goto Step_EnterSerialNumber;
							}
						}
					}

                    if (!foundSerialNumberInLinkedSerialNumbers)
                    {
                        numberOfNewNotLinkedSerialNumbersAllowed -= 1;
                    }

                    DataRow rowToAdd = dsSerialNumber.Tables[0].NewRow();
                    rowToAdd[SerialNumberDataSet.Columns.SERIALNUMBER.Name] = serialNumber;
                    dsSerialNumber.Tables[0].Rows.InsertAt(rowToAdd, 0);

                    //if (Convert.ToDouble(this.GetNumberOfRows(dsSerialNumber)) == StillToQuantity.Get())
                    //{
                    //    //enough serial numbers entered, so send message
                    //    initialErrorKey = "MSG_ALL_NEEDED_SERIAL_NUMBER_ENTERED";
                    //    initialErrorKeyIsError = false;
                    //    goto Step_EnterSerialNumber;
                    //}
                }

                goto Step_EnterSerialNumber;

				#endregion
			}
            if (msg.Name.EndsWith(".SerialNumberRangeScanned"))
			{
				#region RANGE SCANNED

				if (maxQtyForSerial > 0 &&
                    Convert.ToDouble(this.GetNumberOfRows(dsSerialNumber)) >= maxQtyForSerial)
                {
                    //maximum serial numbers entered, so send error
                    initialErrorKey = "MSG_ERROR_NO_MORE_SERIAL_NUMBER_NEEDED";
                    goto Step_EnterSerialNumber;
                }

                string startSerialNumber = ExtractParameter<string>(msg.Parameters, "startSerialNumber");
                string endSerialNumber = ExtractParameter<string>(msg.Parameters, "endSerialNumber");

                //parse through controller
                if (barcodeController != null)
                {
                    //BarcodeContainer bc = barcodeController.GetSerialNumber(startSerialNumber, null);
                    BarcodeContainer bc = ExtractParameter<BarcodeContainer>(msg.Parameters, "barcodeContainerStart");
                    if (!string.IsNullOrEmpty(bc.SerialNumber))
                    {
                        startSerialNumber = bc.SerialNumber;

                        //check if correct data was scanned
                        if (!string.IsNullOrEmpty(bc.ItemCode) &&
                            bc.ItemCode != ItemInfo.Get().ItemCode)
                        {
                            //incorrect item
                            initialErrorParams = new object[3] { startSerialNumber, ItemInfo.Get().ItemCode, bc.ItemCode };
                            initialErrorKey = "MSG_ERROR_SERIAL_NUMBER_NOT_MATCHES_NEEDED_ITEM";
                            goto Step_EnterSerialNumber;
                        }

                        if (bc.GS1DataObject != null &&
                            !string.IsNullOrEmpty(bc.GS1DataObject.LotNumber) &&
                           bc.GS1DataObject.LotNumber != BatchNumber.Get())
                        {
                            //incorrect item
                            initialErrorParams = new object[3] { startSerialNumber, BatchNumber.Get(), bc.GS1DataObject.LotNumber };
                            initialErrorKey = "MSG_ERROR_SERIAL_NUMBER_NOT_MATCHES_NEEDED_BATCH";
                            goto Step_EnterSerialNumber;
                        }

                    }

                    //bc = barcodeController.GetSerialNumber(endSerialNumber, null);
                    bc = ExtractParameter<BarcodeContainer>(msg.Parameters, "barcodeContainerEnd");
                    if (!string.IsNullOrEmpty(bc.SerialNumber))
                    {
                        endSerialNumber = bc.SerialNumber;

                        //check if correct data was scanned
                        if (!string.IsNullOrEmpty(bc.ItemCode) &&
                            bc.ItemCode != ItemInfo.Get().ItemCode)
                        {
                            //incorrect item
                            initialErrorParams = new object[3] { endSerialNumber, ItemInfo.Get().ItemCode, bc.ItemCode };
                            initialErrorKey = "MSG_ERROR_SERIAL_NUMBER_NOT_MATCHES_NEEDED_ITEM";
                            goto Step_EnterSerialNumber;
                        }

                        if (bc.GS1DataObject != null &&
                            !string.IsNullOrEmpty(bc.GS1DataObject.LotNumber) &&
                           bc.GS1DataObject.LotNumber != BatchNumber.Get())
                        {
                            //incorrect item
                            initialErrorParams = new object[3] { endSerialNumber, BatchNumber.Get(), bc.GS1DataObject.LotNumber };
                            initialErrorKey = "MSG_ERROR_SERIAL_NUMBER_NOT_MATCHES_NEEDED_BATCH";
                            goto Step_EnterSerialNumber;
                        }

                    }



                }






                DocumentRef docRef = new DocumentRef(isDefinedObjectType ? ObjectType.Get() : ((int)SboLinkDocumentType.NoLink).ToString(), (DocEntry != null && DocEntry.Get().HasValue) ? DocEntry.Get().Value : -1);

                Collection<string> createdSerialNumberRange = this.ExecuteMethodWithDbConnection<Collection<string>>(out pmxError, false, false,
                     delegate(PmxDbConnection conn, object[] parameters)
                     {
                         PmxSerialNumberProvider serProv = new PmxSerialNumberProvider(conn);
                         return serProv.CreateSerialNumberRange(startSerialNumber, endSerialNumber, docRef);
                     });

                if (pmxError != null)
                {
                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                        this.DefaultCultureInfo, BuildParamCollection(
                        "PmxError", pmxError,
                        "ShowButton", true));
                    msg = WaitForMessage();

                    goto Step_EnterSerialNumber;
                }

                if (maxQtyForSerial > 0 &&
                    (Convert.ToDouble(this.GetNumberOfRows(dsSerialNumber)) + createdSerialNumberRange.Count) > maxQtyForSerial)
                {
                    //maximum serial numbers entered, so send error
                    initialErrorKey = "MSG_ERROR_SERIAL_NUMBER_RANGE_QUANTITY_EXCEEDS_MAXIMUM";
                    goto Step_EnterSerialNumber;
                }

                foreach (string serialNumber in createdSerialNumberRange)
                {
                    DataRow[] rows = dsSerialNumber.Tables[0].Select(string.Format("{0} = '{1}'", SerialNumberDataSet.Columns.SERIALNUMBER.Name, serialNumber));
                    if (rows.Length > 0)
                    {
                        initialErrorKey = "MSG_ERROR_SERIAL_NUMBER_IN_RANGE_ALREADY_SCANNED";
                        break;
                    }
                }

                if (string.IsNullOrEmpty(initialErrorKey))
                {
					warningsForSerialNumbers = null;

                    if (isDefinedObjectType)
                    {

						//Is serial number allowed?
						List<string> tempFullListOfSerialNumbers = new List<string>(createdSerialNumberRange);
						foreach (DataRow row in dsSerialNumber.Tables[0].Rows)
						{
							//add to list
							tempFullListOfSerialNumbers.Add(Convert.ToString(row[SerialNumberDataSet.Columns.SERIALNUMBER.Name]));
						}

                        pmxError = ValidateSerialNumbers(createdSerialNumberRange, LocationCode.Get(), currentDestinationLocationCode, currentListOfLineNumbers, ItemInfo.Get().ItemCode, tempFullListOfSerialNumbers, ref warningsForSerialNumbers, useTrack);


                        if (pmxError != null)
                        {
                            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                                this.DefaultCultureInfo, BuildParamCollection(
                                "PmxError", pmxError,
                                "ShowButton", true));
                            msg = WaitForMessage();

                            goto Step_EnterSerialNumber;
                        }

                    }

					if (warningsForSerialNumbers != null &&
						warningsForSerialNumbers.Count > 0)
					{
						//User needs to confirm serial numbers
						foreach (string warnSerialNumber in warningsForSerialNumbers.Keys)
						{
							session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
								DefaultCultureInfo.Get(), BuildParamCollection(
									"TitleKey", "MSG_TITLE_CONFIRM_SERIAL_NUMBER_WARNING",
									"MessageKey", warningsForSerialNumbers[warnSerialNumber].MessageKey,
									"Parameters", warningsForSerialNumbers[warnSerialNumber].MessageParams
									));
										msg = WaitForMessage();

							if (msg.Name.EndsWith(".No"))
							{
								//Serial number not confirmed, so remove from list
								if (createdSerialNumberRange.Contains(warnSerialNumber))
								{
									createdSerialNumberRange.Remove(warnSerialNumber);
								}
							}
						}
					}

                    double tempNumberOfNewNotLinkedSerialNumbersAllowed = numberOfNewNotLinkedSerialNumbersAllowed;

                    foreach (string serialNumber in createdSerialNumberRange)
                    {
						if (currentListOfSerialNumbersAlreadyEntered != null &&
							currentListOfSerialNumbersAlreadyEntered.Count > 0 &&
							currentListOfSerialNumbersAlreadyEntered.Contains(serialNumber))
						{
							initialErrorKey = "MSG_ERROR_SERIAL_NUMBER_NOT_ALLOWED";
							goto Step_EnterSerialNumber;
						}

						bool foundSerialNumberInLinkedSerialNumbers = false;
                        if (currentListOfSerialNumbersToUse != null)
                        {

                            //check if it is valid by serial numbers to use
                            foreach (SerialNumberInfo serInfo in currentListOfSerialNumbersToUse)
                            {
                                if (serInfo.SerialNumber == serialNumber)
                                {
                                    //we found serial number
                                    foundSerialNumberInLinkedSerialNumbers = true;
                                }
                            }


                            if (!foundSerialNumberInLinkedSerialNumbers)
                            {
                                if (tempNumberOfNewNotLinkedSerialNumbersAllowed < 1)
                                {
                                    //serial number is not linked, and no new serial numbers are allowed
                                    initialErrorKey = "MSG_ERROR_NEW_SERIAL_NUMBER_CREATION_NOT_ALLOWED";
                                    goto Step_EnterSerialNumber;
                                }
                                else
                                {
                                    tempNumberOfNewNotLinkedSerialNumbersAllowed -= 1;
                                }
                            }
                        }
                    }

                    //set deducted quantities
                    numberOfNewNotLinkedSerialNumbersAllowed = tempNumberOfNewNotLinkedSerialNumbersAllowed;


                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                     DefaultCultureInfo.Get(), BuildParamCollection(
                         "TitleKey", "MSG_TITLE_CONFIRM_NUMBER_OF_SERIAL_NUMBERS",
                         "MessageKey", "MSG_QUESTION_CONFIRM_NUMBER_OF_SERIAL_NUMBERS",
                         "Parameters", new object[] { createdSerialNumberRange.Count }));
                    msg = WaitForMessage();

                    if (msg.Name.EndsWith(".No"))
                    {
                        //quantity not correct, so enter is again
                        goto Step_EnterSerialNumber;
                    }



                    foreach (string serialNumber in createdSerialNumberRange)
                    {
                        DataRow rowToAdd = dsSerialNumber.Tables[0].NewRow();
                        rowToAdd[SerialNumberDataSet.Columns.SERIALNUMBER.Name] = serialNumber;
                        //dsSerialNumber.Tables[0].Rows.InsertAt(rowToAdd, 0);
                        dsSerialNumber.Tables[0].Rows.Add(rowToAdd);
                    }

                    //goto Step_SendQuantity;
                    goto Step_EnterSerialNumber;
                }

                goto Step_EnterSerialNumber;

				#endregion
			}
            if (msg.Name.EndsWith(".DeleteSerialNumber"))
            {
                string serialNumberToDelete = ExtractParameter<string>(msg.Parameters, "serialNumber");



                bool foundSerialNumberInLinkedSerialNumbers = false;
                if (currentListOfSerialNumbersToUse != null)
                {

                    //check if it is valid by serial numbers to use
                    foreach (SerialNumberInfo serInfo in currentListOfSerialNumbersToUse)
                    {
                        if (serInfo.SerialNumber == serialNumberToDelete)
                        {
                            //we found serial number
                            foundSerialNumberInLinkedSerialNumbers = true;
                        }
                    }

                }

                if (!foundSerialNumberInLinkedSerialNumbers)
                {
                    numberOfNewNotLinkedSerialNumbersAllowed += 1;
                }




                DataRow[] rows = dsSerialNumber.Tables[0].Select(string.Format("{0} = '{1}'", SerialNumberDataSet.Columns.SERIALNUMBER.Name, serialNumberToDelete));
                foreach (DataRow row in rows)
                {
                    dsSerialNumber.Tables[0].Rows.Remove(row);
                }
                dsSerialNumber.AcceptChanges();
                goto Step_EnterSerialNumber;
            }

            if (msg.Name.EndsWith(".StopRequested"))
            {
                goto Step_SendQuantity;
            }

            #endregion

        Step_ShowSerialList:

            #region SHOW_SERIAL_LIST



            DataSet dsLinkedSerialNumbersForScreen = GetNewLinkedSerialNumberDataSet(currentListOfSerialNumbersToUse, dsSerialNumber);

            //show all linked serial numbers
            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IIdentifyMultipleSerialNumberScreen),
            DefaultCultureInfo.Get(), BuildParamCollection(
                "InitialErrorKey", initialErrorKey,
                "InitialErrorParams", initialErrorParams,
                "InitialErrorKeyIsError", initialErrorKeyIsError,
                "TitleKey", "MSG_TITLE_LINKED_SERIAL_NUMBER",
                "BarcodeController", barcodeController,
                "SerialNumberDS", dsLinkedSerialNumbersForScreen,
                "ItemDescription", ItemInfo.Get().CustomItemDescription,
                "ItemCode", ItemInfo.Get().ItemCode,
                "ItemBarcode", ItemInfo.Get().CodeBars,
                "UOM", uomForSerial,
                "BatchNumber", BatchNumber.Get(),
                "BestBeforeDate", BestBeforeDate.Get(),
                "SSCC", SSCC.Get(),
                "DocNum", DocNum.Get(),
                "StillToQuantity", stillToQuantityForSerial,
                "MessageKeyStillQuantity", MessageKeyStillQuantity.Get(),
                "UseSerialNumberRange", false,
                "OnlyShowList", true,
                "UseUppercase", serialNumbersInUppercase
                ));
            msg = WaitForMessage();

            if (msg.Name.EndsWith(".BackRequested"))
            {
                //Go back
                BackRequested.Set(true);
                return;
            }

            goto Step_EnterSerialNumber;

            #endregion

        Step_SendQuantity:

            #region SEND QUANTITY

            currentQuantity = 0;
            minimum = -1;
            if (MinimumQuantity != null)
            {
                minimum = MinimumQuantity.Get();
            }

            if ((ItemInfo.Get().HasSerialNumber || ItemInfo.Get().HasSAPSerialNumber) &&
                ForceInputSerialNumbers != null &&
                ForceInputSerialNumbers.Get())
            {
                if (this.GetNumberOfRows(dsSerialNumber) > 0)
                {

                    if (minimum >= 0 &&
                        this.GetNumberOfRows(dsSerialNumber) < minimum)
                    {
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                                this.DefaultCultureInfo, BuildParamCollection(
                                "MessageKey", "MSG_ERROR_MINIMUM_QUANTITY_NOT_REACHED",
                                "ShowButton", true,
                                "IsError", true,
                                "Parameters", new object[] { minimum }));
                        msg = WaitForMessage();

                        goto Step_EnterSerialNumber;
                    }
                    foreach (DataRow row in dsSerialNumber.Tables[0].Rows)
                    {
                        //add to list
                        listOfSerialNumbers.Add(Convert.ToString(row[SerialNumberDataSet.Columns.SERIALNUMBER.Name]));
                    }
                    if (ListOfSerialNumbers != null)
                    {
                        ListOfSerialNumbers.Set(listOfSerialNumbers);
                    }
                    currentQuantity = Convert.ToDouble(listOfSerialNumbers.Count);
                }
                else if (!AllowZero.Get())
                {
                    initialErrorKey = "MSG_ERROR_ZERO_QUANTITY_NOT_ALLOWED";
                    goto Step_EnterSerialNumbersStart;
                }
            }
            else
            {

                foreach (PackagingTypeInfo info in listOfPackagingTypes)
                {
                    currentQuantity += (info.Quantity * info.QuantityPerPack);
                }

                if (currentQuantity == 0 &&
                    !AllowZero.Get())
                {
                    initialErrorKey = "MSG_ERROR_ZERO_QUANTITY_NOT_ALLOWED";
                    goto Step_EnterQuantityByPackagingType;
                }
            }



            if (innerQuantity > 0)
            {
                //in case we have number of items per UOM, we need to adjust qty
                currentQuantity = currentQuantity / innerQuantity;
            }

            currentQuantity = FormattingHelper.RoundSAPDecimal(currentQuantity, StartUpValues.QuantityDecimals);
            double minimumQuantityRounded = FormattingHelper.RoundSAPDecimal(minimum, StartUpValues.QuantityDecimals);
            double maximumQuantityRounded = FormattingHelper.RoundSAPDecimal(MaximumQuantity.Get(), StartUpValues.QuantityDecimals);

            if (minimumQuantityRounded >= 0 && currentQuantity < minimumQuantityRounded)
            {
	            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
		            this.DefaultCultureInfo, BuildParamCollection(
			            "MessageKey", "MSG_ERROR_MINIMUM_QUANTITY_NOT_REACHED",
			            "ShowButton", true,
			            "IsError", true,
			            "Parameters", new object[] { minimum }));
	            msg = WaitForMessage();

	            goto Step_CheckPackagingTypes;
            }
            else if (maximumQuantityRounded >= 0 && currentQuantity > maximumQuantityRounded)
            {
	            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
		            this.DefaultCultureInfo, BuildParamCollection(
			            "MessageKey", "MSG_ERROR_MAXIMUM_QUANTITY_EXCEEDED",
			            "ShowButton", true,
			            "IsError", true));
	            msg = WaitForMessage();

	            BackRequested.Set(true);
	            return;
            }

			QuantityEntered.Set(currentQuantity);



            return;

            #endregion

        Step_CatchWeightEnterQuantity:


            #region CATCH WEIGHT: ENTER QUANTITY

            PmxUomToUse uomForAction = PmxUomToUse.UOM1AndUOM2;

            double weightTolerancePercentage = itemInfo.CatchWeightWeightTolerancePercentage;

            switch (ObjectType.Get())
            {
                case Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxObjectTypes.PmxMoveOrder:
                case Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxObjectTypes.PmxMove:
                    uomForAction = itemInfo.UomToUseForInventoryTransitions;
                    break;
                case Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxObjectTypes.PmxPickList:
                case SboObjectTypes.SalesReturn:
                    uomForAction = itemInfo.UomToUseForSales;
                    break;
                case Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.SboObjectTypes.ProductionOrder:
                    uomForAction = PmxUomToUse.UOM1AndUOM2;
                    //No tolerance allowed for production because tolerance is already set on production order line.
                    weightTolerancePercentage = 0;
                    break;
                case SboObjectTypes.PurchaseReturn:
                    uomForAction = itemInfo.UomToUseForPurchase;
                    break;
                default:
                    uomForAction = PmxUomToUse.UOM1AndUOM2;
                    break;
            }



            askForPieces = uomForAction == PmxUomToUse.UOM1AndUOM2 ||
                                uomForAction == PmxUomToUse.UOM1;
            askForWeight = (uomForAction == PmxUomToUse.UOM1AndUOM2 ||
                            uomForAction == PmxUomToUse.UOM2);

            if (currentOverrideAskingWeight &&
                uomForAction != PmxUomToUse.UOM1AndUOM2)
            {
                //Override asking for weight, so no weight is asked.
                //But now we should always ask for pieces, because we need some quantity.
                askForWeight = false;
                askForPieces = true;
            }





            uomForWeight = itemInfo.Uom2;
            uomForPieces = itemInfo.InventoryUom;
            numberOfDecimalsForWeight = itemInfo.Uom2Decimals;
            numberOfDecimalsForPieces = itemInfo.UomDecimals;
            stillToQuantityForPieces = FormattingHelper.RoundSAPDecimal(stillToInventoryQuantity, numberOfDecimalsForPieces);
            maxQuantityForPieces = FormattingHelper.RoundSAPDecimal(maxInventoryQuantity, numberOfDecimalsForPieces);

            if (currentStillToQuantityUom2.HasValue)
            {
                stillToQuantityForWeight = currentStillToQuantityUom2.Value;
                if (!PmxItemAllConnectionsProvider.IsCatchWeightWithinTolerance(stillToInventoryQuantity, stillToQuantityForWeight, itemInfo))
                {
                    //It is not within the tolerance, so take the default ratio
                    stillToQuantityForWeight = PmxItemAllConnectionsProvider.CalculateWeightFromPieces(stillToInventoryQuantity, itemInfo).Value;
                }
            }
            else
            {
                stillToQuantityForWeight = PmxItemAllConnectionsProvider.CalculateWeightFromPieces(stillToInventoryQuantity, itemInfo).Value;
            }




            autoQuantityForPieces = null;
            if (currentCatchWeightPieces.HasValue &&
                currentCatchWeightPieces.Value > 0)
            {
                quantityForPieces = currentCatchWeightPieces;
                autoQuantityForPieces = currentCatchWeightPieces;
                askForPieces = false;
            }

            if (!askForPieces && 
                stillToQuantityForPieces > 0 &&
                !autoQuantityForPieces.HasValue)
            {
                autoQuantityForPieces = stillToQuantityForPieces;
            }

           

            if (askForPieces)
            {

                if ((listOfPackagingTypes != null && listOfPackagingTypes.Count > 0) ||
                    ItemInfo.Get().ListOfPackagingTypes.Count > 0)
                {

                    goto Step_EnterQuantityByPackagingType;

                }
                else
                {
                    if (!currentUsePickingInfo)
                    {

                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IEnterQuantityWithItemInfoScreen),
                            DefaultCultureInfo.Get(), BuildParamCollection(
                            "InitialErrorKey", initialErrorKey,
                            "TitleKey", TitleKey.Get(),
                            "BarcodeController", barcodeController,
                            "ItemDescription", ItemInfo.Get().CustomItemDescription,
                            "ItemCode", ItemInfo.Get().ItemCode,
                            "ItemBarcode", ItemInfo.Get().CodeBars,
                            "InitialQuantity", 0,
                            "InnerQuantity", 1,
                            "MaximumQuantity", maxQuantityForPieces,
                            "NumberOfDigitsAfterDecimal", numberOfDecimalsForPieces,
                            "InnerUOM", null,
                            "UOM", uomForPieces,
							"BarcodesAndUomQuantities", ItemInfo.Get().PurchaseBarcodesAndUomQuantities,
							"MessageKeyBatchnumber", MessageKeyBatchnumber == null ? null : MessageKeyBatchnumber.Get(),
                            "BatchNumber", BatchNumber.Get(),
                            "BestBeforeDate", BestBeforeDate.Get(),
                            "SSCC", SSCC.Get(),
                            "DocNum", DocNum.Get(),
                            "StillToQuantity", stillToQuantityForPieces,
                            "MessageKeyStillQuantity", MessageKeyStillQuantity.Get(),
                            "AllowZero", AllowZero.Get(),
                            "MessageKeySSCC", currentMessageKeySSCC,
							"SetFocusToQuantityControl", setFocusToQuantityControl
                            ));
                    }
                    else
                    {
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.Picking.IEnterQuantityWithPickingInfoScreen),
                            DefaultCultureInfo.Get(), BuildParamCollection(
                            "InitialErrorKey", initialErrorKey,
                            "TitleKey", TitleKey.Get(),
                            "BarcodeController", barcodeController,
                            "ItemDescription", ItemInfo.Get().CustomItemDescription,
                            "ItemCode", ItemInfo.Get().ItemCode,
                            "ItemBarcode", ItemInfo.Get().CodeBars,
                            "InitialQuantity", 0,
                            "InnerQuantity", 1,
                            "MaximumQuantity", maxQuantityForPieces,
                            "NumberOfDigitsAfterDecimal", numberOfDecimalsForPieces,
                            "InnerUOM", null,
                            "UOM", uomForPieces,
							"BarcodesAndUomQuantities", ItemInfo.Get().SalesBarcodesAndUomQuantities,
							"BatchNumber", BatchNumber.Get(),
                            "BestBeforeDate", BestBeforeDate.Get(),
                            "SSCC", SSCC.Get(),
                            "IsAlternate", currentIsAlternatePicking,
                            "DocNum", DocNum.Get(),
                            "StillToPick", stillToQuantityForPieces,
                            "MessageKeyStillQuantity", MessageKeyStillQuantity.Get(),
                            "AllowZero", AllowZero.Get(),
                            "TotalQuantityToPick", TotalQuantityToPick.Get(),
                            "LocationCode", LocationCode.Get(),
                            "HidePickingLocation", currentHidePickingLocation, 
                            "ImagePath", ItemInfo.Get().PictureName,
                            "MessageKeyBatchnumber", MessageKeyBatchnumber == null ? null : MessageKeyBatchnumber.Get()
                            ));
                    }

                    msg = WaitForMessage();

                    // reset error
                    initialErrorKey = null;

                    if (msg.Name.EndsWith(".QuantityEntered"))
                    {
                        quantityForPieces = ExtractParameter<double>(msg.Parameters, "quantity");
                    }
                    else if (msg.Name.EndsWith(".BackRequested"))
                    {
                        BackRequested.Set(true);
                        return;
                    }
                }
            }


            goto Step_AskWeight;


        Step_AfterEnterQuantityByPackagingTypeCatchWeight:

            double tempQty = 0;

            foreach (PackagingTypeInfo info in listOfPackagingTypes)
            {
                tempQty += (info.Quantity * info.QuantityPerPack);
            }

			quantityForPieces = FormattingHelper.RoundSAPDecimal(tempQty, itemInfo.UomDecimals);

        Step_AskWeight:

            double totalInvQtyScanned = 0;
			//reset qty
			quantityForWeight = null;

            double? weightInStock = currentCurrentWeight;



            if (askForWeight)
            {

                if (quantityForPieces.HasValue)
                {
                    if (stillToQuantityForPieces != quantityForPieces.Value)
                    {
                        //Quantity changed, so we cannot show current weight in stock, because it is not correct anymore
                        weightInStock = null;
                    }

                    //Adjust still to weight, according to entered pieces
                        if (currentStillToQuantityUom2.HasValue)
                    {
                        stillToQuantityForWeight = currentStillToQuantityUom2.Value;
                        if (!PmxItemAllConnectionsProvider.IsCatchWeightWithinTolerance(quantityForPieces.Value, stillToQuantityForWeight, itemInfo) ||
							quantityForPieces != stillToInventoryQuantity)
                        {
                            //It is not within the tolerance, so take the default ratio
                            stillToQuantityForWeight = PmxItemAllConnectionsProvider.CalculateWeightFromPieces(quantityForPieces.Value, itemInfo).Value;
                        }
                    }
                    else
                    {
                        stillToQuantityForWeight = PmxItemAllConnectionsProvider.CalculateWeightFromPieces(quantityForPieces.Value, itemInfo).Value;
                    }


                    if (itemInfo.CatchWeightWeightTolerancePercentage >= 100)
                    {
                        //Tolerance greater than 100%, so actually no maximum is required
                        maxQuantityForWeight = -1;
                    }
                    else
                    {
                        //Calculate weight maximum
                        double? tempMax = PmxItemAllConnectionsProvider.GetMaximumWeightForCatchWeightItem(quantityForPieces.Value, itemInfo);
                        if (tempMax.HasValue)
                        {
                            maxQuantityForWeight = tempMax.Value;
                        }
                    }
                }
                //No pieces have been entered, but there is a maximum for pieces, so calculate max qty
                else if (maxQuantityForPieces >= 0)
                {
                    //Calculate weight maximum
                    double? tempMax = PmxItemAllConnectionsProvider.GetMaximumWeightForCatchWeightItem(maxQuantityForPieces, itemInfo);
                    if (tempMax.HasValue)
                    {
                        maxQuantityForWeight = tempMax.Value;
                    }
                }

                totalInvQtyScanned = 0;

                //Get quantity from scanned barcode in previous steps.
                if (currentScannedBarcodeContainer != null)
                {
                    quantityForWeight = BarcodeHelper.GetQuantityForMeasureType(itemInfo.Uom2GS1MeasureType, currentScannedBarcodeContainer, null);
                    if (quantityForWeight.HasValue)
                    {
                        totalInvQtyScanned += PmxItemAllConnectionsProvider.CalculatePiecesFromWeight(quantityForWeight.Value, itemInfo).Value;
                    }
                }



            Step_NextWeight:


				double? tempMaxToUse = null;

				double calculatedQuantityPieces = 0;

				if (itemInfo.CatchWeightScanWeightForEachCase)
				{
					//Scan each piece
					calculatedQuantityPieces = itemInfo.CatchWeightQuantityInCase;

					//It is possible that number of decimals is larger than 0, which means that it is not really pieces.
					//So we need to check if the remaining quantity is lower than 1.
					//If this is the case, we need to use this quantity!
					if (itemInfo.UomDecimals > 0 &&
						((quantityForPieces.HasValue ? quantityForPieces.Value : maxQuantityForPieces) - totalInvQtyScanned) < itemInfo.CatchWeightQuantityInCase)
					{
						calculatedQuantityPieces = (quantityForPieces.HasValue ? quantityForPieces.Value : maxQuantityForPieces) - totalInvQtyScanned;
					}

					tempMaxToUse = PmxItemAllConnectionsProvider.GetMaximumWeightForCatchWeightItem(calculatedQuantityPieces, itemInfo);

					if(totalInvQtyScanned == 0)
					{
						//This is the first time asking for weight, so allow to enter full quantity
						tempMaxToUse = PmxItemAllConnectionsProvider.GetMaximumWeightForCatchWeightItem((quantityForPieces.HasValue ? quantityForPieces.Value : maxQuantityForPieces) - totalInvQtyScanned, itemInfo);
					}

				}
				else
				{
					tempMaxToUse = PmxItemAllConnectionsProvider.GetMaximumWeightForCatchWeightItem((quantityForPieces.HasValue ? quantityForPieces.Value : maxQuantityForPieces) - totalInvQtyScanned, itemInfo);
				}

                double maxQuantityForWeightToUse = maxQuantityForWeight == -1 ? -1 : tempMaxToUse.HasValue ? tempMaxToUse.Value : -1;


                if (!currentUsePickingInfo)
                {

                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IEnterQuantityWithItemInfoScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                        "InitialErrorKey", initialErrorKey,
                        "TitleKey", TitleKeyWeight == null ? "MSG_TITLE_ENTER_WEIGHT" : TitleKeyWeight.Get(),
                        "BarcodeController", barcodeController,
                        "ItemDescription", ItemInfo.Get().CustomItemDescription,
                        "ItemCode", ItemInfo.Get().ItemCode,
                        "ItemBarcode", ItemInfo.Get().CodeBars,
                        "InitialQuantity", 0,
                        "InnerQuantity", 1,
                        "MaximumQuantity", maxQuantityForWeightToUse,
                        "NumberOfDigitsAfterDecimal", numberOfDecimalsForWeight,
                        "InnerUOM", null,
                        "UOM", uomForWeight,
						"BarcodesAndUomQuantities", ItemInfo.Get().PurchaseBarcodesAndUomQuantities,
						"MessageKeyBatchnumber", MessageKeyBatchnumber == null ? null : MessageKeyBatchnumber.Get(),
                        "BatchNumber", BatchNumber.Get(),
                        "BestBeforeDate", BestBeforeDate.Get(),
                        "SSCC", SSCC.Get(),
                        "DocNum", DocNum.Get(),
                        "StillToQuantity", stillToQuantityForWeight,
                        "MessageKeyStillQuantity", currentMessageKeyStillQuantityWeight,
                        "MessageKeySSCC", currentMessageKeySSCC,
                        "InfoMessageKey", (autoQuantityForPieces.HasValue) ? "MSG_LBL_NUMBER_OF_PIECES" : null,
                        "InfoValue", (autoQuantityForPieces.HasValue) ? autoQuantityForPieces.Value.ToString() : null,
                        "ForceGS1_128", true,
                        "GS1WeightAI", itemInfo.Uom2GS1MeasureType,
                        "UomToDisplayOnQtyProvider", itemInfo.Uom2,
                        "QtyEntered", quantityForWeight.HasValue ? quantityForWeight.Value : 0,
                        "AllowZero", true,
                        "DefaultQuantity", weightInStock,
                        "DefaultQuantityMessageKey", "MSG_LBL_CURRENT_WEIGHT",
						"SetFocusToQuantityControl", setFocusToQuantityControl
                        ));
                }
                else
                {

                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.Picking.IEnterQuantityWithPickingInfoScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                        "InitialErrorKey", initialErrorKey,
                        "TitleKey", TitleKeyWeight == null ? "MSG_TITLE_ENTER_WEIGHT" : TitleKeyWeight.Get(),
                        "BarcodeController", barcodeController,
                        "ItemDescription", ItemInfo.Get().CustomItemDescription,
                        "ItemCode", ItemInfo.Get().ItemCode,
                        "ItemBarcode", ItemInfo.Get().CodeBars,
                        "InitialQuantity", 0,
                        "InnerQuantity", 1,
                        "MaximumQuantity", maxQuantityForWeightToUse,
                        "NumberOfDigitsAfterDecimal", numberOfDecimalsForWeight,
                        "InnerUOM", null,
                        "UOM", uomForWeight,
						"BarcodesAndUomQuantities", ItemInfo.Get().SalesBarcodesAndUomQuantities,
						"BatchNumber", BatchNumber.Get(),
                        "BestBeforeDate", BestBeforeDate.Get(),
                        "SSCC", SSCC.Get(),
                        "IsAlternate", currentIsAlternatePicking,
                        "DocNum", DocNum.Get(),
                        "StillToPick", stillToQuantityForWeight,
                        "MessageKeyStillQuantity", currentMessageKeyStillQuantityWeight,
                        "TotalQuantityToPick", (autoQuantityForPieces.HasValue) ? autoQuantityForPieces.Value : TotalQuantityToPick.Get(),
                        "LocationCode", LocationCode.Get(),
                        "HidePickingLocation", currentHidePickingLocation, 
                        "ImagePath", ItemInfo.Get().PictureName,
                        "MessageKeyBatchnumber", MessageKeyBatchnumber == null ? null : MessageKeyBatchnumber.Get(),
                        "TotalQuantityToPickMessageKey", (autoQuantityForPieces.HasValue) ? "MSG_LBL_NUMBER_OF_PIECES" : null,
                        "ForceGS1_128", true,
                        "GS1WeightAI", itemInfo.Uom2GS1MeasureType,
                        "UomToDisplayOnQtyProvider", itemInfo.Uom2,
                        "QtyEntered", quantityForWeight.HasValue ? quantityForWeight.Value : 0,
                        "AllowZero", true,
						"InfoMessageKey", "MSG_LBL_NUMBER_OF_PIECES",
						"InfoValue", string.Format("{0}/{1}", totalInvQtyScanned, quantityForPieces.HasValue ? quantityForPieces.Value: stillToQuantityForPieces),
                        "DefaultQuantity", weightInStock,
                        "DefaultQuantityMessageKey", "MSG_LBL_CURRENT_WEIGHT"


                        ));
                }


                msg = WaitForMessage();

                // reset error
                initialErrorKey = null;

                if (msg.Name.EndsWith(".QuantityEntered"))
                {
                    double tempWeight = ExtractParameter<double>(msg.Parameters, "quantity");
                    if (tempWeight != 0)
                    {
                        if (!quantityForWeight.HasValue)
                        {
                            quantityForWeight = 0;
                        }
						double tempInvQty = 0;
						if (itemInfo.CatchWeightScanWeightForEachCase)
						{
							//Regard each scan as the number of pieces in a case.
							tempInvQty = calculatedQuantityPieces;

							
							//Check if this is within tolerance. when it is the first time
							if (totalInvQtyScanned == 0 &&
								!PmxItemAllConnectionsProvider.IsCatchWeightWithinTolerance(tempInvQty, tempWeight, itemInfo) &&
								quantityForPieces.HasValue)
							{
								//If not, check if it is within tolerance of total quantity
								if (PmxItemAllConnectionsProvider.IsCatchWeightWithinTolerance(quantityForPieces.Value, tempWeight, itemInfo))
								{
									//It is within tolerance, so regard this as a weight for the total quantity
									tempInvQty = quantityForPieces.Value;
								}
							}

							

						}
						else
						{
							tempInvQty = PmxItemAllConnectionsProvider.CalculatePiecesFromWeight(tempWeight, itemInfo).Value;
						}

                        if (maxQuantityForWeight > 0 &&
                            (tempWeight + quantityForWeight.Value) > maxQuantityForWeight)
                        {
                            initialErrorKey = "MSG_ERROR_MAXIMUM_QUANTITY_EXCEEDED";
                            goto Step_NextWeight;
                        }

						if (!PmxItemAllConnectionsProvider.IsCatchWeightWithinTolerance(tempInvQty, tempWeight, itemInfo))
						{
							session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
							   this.DefaultCultureInfo, BuildParamCollection(
							   "MessageKey", "MSG_ERROR_CW_WEIGHT_NOT_WITHIN_TOLERANCE",
							   "ShowButton", true,
							   "IsError", true,
							   "Parameters", new object[] { tempWeight, tempInvQty, itemInfo.CatchWeightWeightTolerancePercentage }));
									msg = WaitForMessage();

							goto Step_NextWeight;
						}

                        totalInvQtyScanned += tempInvQty;
                        quantityForWeight += tempWeight;

                        if (this.WeightDetails.HasValue())
                        {
                            this.WeightDetails.Get().Add(new KeyValuePair<double, double>(tempInvQty, tempWeight));
                        }

                        if ((!quantityForPieces.HasValue ||
                            (quantityForPieces.HasValue && totalInvQtyScanned < quantityForPieces.Value)) &&
                            ( maxQuantityForPieces < 0 || maxQuantityForPieces > totalInvQtyScanned))
                        {
                            //Pieces were asked, and the number of pieces was not reached yet
                            //OR maximum quantity for pieces was reached
                            //So ask for next weight.
                            goto Step_NextWeight;
                        }
                    }
                    else
                    {
                        //When zero is not allowed, and the total entered weight is zero, show message.
                        //OR when a number of pieces has been entered, and o weight has been entered
                        if ((!AllowZero.Get() && (!quantityForWeight.HasValue || quantityForWeight.Value == 0)) ||
							(quantityForPieces.HasValue && (!quantityForWeight.HasValue || quantityForWeight.Value == 0)))
                        {
                            initialErrorKey = "MSG_ERROR_ZERO_QUANTITY_NOT_ALLOWED";
                            goto Step_NextWeight;
                        }

                    }

                }
                else if (msg.Name.EndsWith(".BackRequested"))
                {
                   if (askForPieces)
                    {
                        goto Step_CatchWeightEnterQuantity;
                    }

                    BackRequested.Set(true);
                    return;
                }
            }



            //Now calculate and set quantities.

            if (!quantityForWeight.HasValue)
            {
                //Check if there was weight on the barcode.
                //If so, use this weight if it is within tolerance
                //Get quantity from scanned barcode in previous steps.
                if (currentScannedBarcodeContainer != null)
                {
                    double? tempQuantityForWeight = BarcodeHelper.GetQuantityForMeasureType(itemInfo.Uom2GS1MeasureType, currentScannedBarcodeContainer, null);
                    if (tempQuantityForWeight.HasValue &&
                        quantityForPieces.HasValue &&
                        PmxItemAllConnectionsProvider.IsCatchWeightWithinTolerance(quantityForPieces.Value, tempQuantityForWeight.Value, itemInfo))
                    {
                        quantityForWeight = tempQuantityForWeight;
                    }
                }

                if (!quantityForWeight.HasValue)
                {
                    quantityForWeight = PmxItemAllConnectionsProvider.CalculateWeightFromPieces(quantityForPieces.Value, itemInfo);
                }
            }
            else if (!quantityForPieces.HasValue)
            {
                if (totalInvQtyScanned > 0)
                {
                    quantityForPieces = totalInvQtyScanned;
                }
                else
                {
                    quantityForPieces = PmxItemAllConnectionsProvider.CalculatePiecesFromWeight(quantityForWeight.Value, itemInfo);
                }
            }

            


            minimum = -1;
            if (MinimumQuantity != null)
            {
                minimum = MinimumQuantity.Get();
            }

           
            if (minimum >= 0 &&
                quantityForPieces.Value < minimum)
            {
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                        this.DefaultCultureInfo, BuildParamCollection(
                        "MessageKey", "MSG_ERROR_MINIMUM_QUANTITY_NOT_REACHED",
                        "ShowButton", true,
                        "IsError", true,
                        "Parameters", new object[] { minimum }));
                msg = WaitForMessage();

                goto Step_CatchWeightEnterQuantity;
            }

            //Check if quantity is within tolerance
            if (!PmxItemAllConnectionsProvider.IsCatchWeightWithinTolerance(quantityForPieces.Value, quantityForWeight.Value, itemInfo))
            {
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                        this.DefaultCultureInfo, BuildParamCollection(
                        "MessageKey", "MSG_ERROR_CW_WEIGHT_NOT_WITHIN_TOLERANCE",
                        "ShowButton", true,
                        "IsError", true,
                        "Parameters", new object[] { quantityForWeight.Value, quantityForPieces.Value, itemInfo.CatchWeightWeightTolerancePercentage }));
                msg = WaitForMessage();

                goto Step_CatchWeightEnterQuantity;
            }


            if (innerQuantity > 0)
            {
                //in case we have number of items per UOM, we need to adjust qty
                quantityForPieces = quantityForPieces.Value / innerQuantity;
            }
            quantityForPieces = FormattingHelper.RoundSAPDecimal(quantityForPieces.Value, numberOfDecimalsForQuantityWithInnerQuantity);

            quantityForWeight = FormattingHelper.RoundSAPDecimal(quantityForWeight.Value, itemInfo.Uom2Decimals);


            QuantityEntered.Set(quantityForPieces.Value);
            QuantityUom2Entered.Set(quantityForWeight.Value);
            




            return;
            


            #endregion


        }

		#endregion

		#region HELPERS

		/// <summary>
		/// Validates the serial numbers.
		/// </summary>
		/// <param name="serialNumber">The serial number.</param>
		/// <param name="location">The location.</param>
		/// <param name="destinationLocationCode">The destination location code.</param>
		/// <param name="listOfLineNumbers">The list of line numbers.</param>
		/// <param name="itemCode">The item code.</param>
		/// <param name="warnings">The warnings.</param>
		/// <param name="useTrack">The use track.</param>
		/// <returns></returns>
		private ProdumexError ValidateSerialNumbers(string serialNumber, string location, string destinationLocationCode, Collection<int> listOfLineNumbers, string itemCode, IList<string> fullListOfSerialNumbers, ref PmxDictionary<string, SerialNumberWarnReply> warnings, bool useTrack)
        {
            Collection<string> list = new Collection<string>();
            list.Add(serialNumber);
            return ValidateSerialNumbers(list, location, destinationLocationCode, listOfLineNumbers, itemCode, fullListOfSerialNumbers, ref warnings, useTrack);
        }

		/// <summary>
		/// Validates the serial numbers.
		/// </summary>
		/// <param name="serialNumbers">The serial numbers.</param>
		/// <param name="location">The location.</param>
		/// <param name="destinationLocationCode">The destination location code.</param>
		/// <param name="listOfLineNumbers">The list of line numbers.</param>
		/// <param name="itemCode">The item code.</param>
		/// <param name="fullListOfSerialNumbers">The full list of serial numbers.</param>
		/// <param name="warnings">The warnings.</param>
		/// <param name="useTrack">The use track.</param>
		/// <returns></returns>
		private ProdumexError ValidateSerialNumbers(Collection<string> serialNumbers, string location, string destinationLocationCode, Collection<int> listOfLineNumbers, string itemCode, IList<string> fullListOfSerialNumbers, ref PmxDictionary<string, SerialNumberWarnReply> warnings, bool useTrack)
        {
            ProdumexError pmxError = null;
            //Is serial number allowed?
            Collection<ProdumexError> listOfErrors = null;

            Collection<string> fullListOfSerialNumbersTemp = new Collection<string>(fullListOfSerialNumbers);


            string pmxWarehouseCode = null;

			PmxDictionary<string, SerialNumberWarnReply> warningsTemp = warnings;

            if (!string.IsNullOrEmpty(location))
            {
                pmxWarehouseCode = this.ExecuteMethodWithDbConnection<PmxOseWarehouseInfo>(out pmxError, false, false,
                                  delegate(PmxDbConnection conn, object[] parameters)
                                  {
                                      PmxOseProvider prov = new PmxOseProvider(conn);
                                      return prov.GetPmxWarehouseInfo(location);
                                  }).PmxWarehouseCode;
            }

            switch (ObjectType.Get())
            {
                case Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxObjectTypes.PmxPickList:

                    listOfErrors = this.ExecuteMethodWithDbConnection<Collection<ProdumexError>>(out pmxError, false, false,
                             delegate(PmxDbConnection conn, object[] parameters)
                             {
                                 PmxSerialNumberProvider serProv = new PmxSerialNumberProvider(conn);
								 return serProv.IsSerialNumberAllowed(ObjectType.Get(), DocEntry == null ? null : DocEntry.Get(), null, serialNumbers, ItriKey.Get(), true, pmxWarehouseCode, null, location, destinationLocationCode, null, null, ItemInfo.Get().ItemCode, currentLUID, null, listOfLineNumbers, fullListOfSerialNumbersTemp, ref warningsTemp);
                             });

                    if (listOfErrors != null)
                    {
                        int pickListDocEntry = 0;
                        if (DocEntry != null &&
                            DocEntry.Get().HasValue)
                        {
                            pickListDocEntry = DocEntry.Get().Value;
                        }
                        pmxError = Produmex.Sbo.Logex.Data.ProdumexErrors.SerialNumberNotValidForPickList(s_log, pickListDocEntry, (serialNumbers.Count == 1) ? serialNumbers[0] : "LIST", itemCode, listOfErrors);
                    }

                    break;
                case SboObjectTypes.PurchaseOrder:

                    listOfErrors = this.ExecuteMethodWithDbConnection<Collection<ProdumexError>>(out pmxError, false, false,
                             delegate(PmxDbConnection conn, object[] parameters)
                             {
								 if (useTrack)
								 {
									 PmxSerialNumberNovitanProvider serProvNov = new PmxSerialNumberNovitanProvider(conn);
									 return serProvNov.IsSerialNumberAllowed(ObjectType.Get(), DocEntry == null ? null : DocEntry.Get(), null, serialNumbers, ItriKey.Get(), true, pmxWarehouseCode, null, location, destinationLocationCode, null, null, ItemInfo.Get().ItemCode, currentLUID, null, listOfLineNumbers, fullListOfSerialNumbersTemp, ref warningsTemp, useTrack);
								 }
								 else {
									 PmxSerialNumberProvider serProv = new PmxSerialNumberProvider(conn);
									 return serProv.IsSerialNumberAllowed(ObjectType.Get(), DocEntry == null ? null : DocEntry.Get(), null, serialNumbers, ItriKey.Get(), true, pmxWarehouseCode, null, location, destinationLocationCode, null, null, ItemInfo.Get().ItemCode, currentLUID, null, listOfLineNumbers, fullListOfSerialNumbersTemp, ref warningsTemp);
								 }	
                             });

                    if (listOfErrors != null)
                    {
                        int purchaseOrderDocEntry = 0;
                        if (DocEntry != null &&
                            DocEntry.Get().HasValue)
                        {
                            purchaseOrderDocEntry = DocEntry.Get().Value;
                        }
                        pmxError = Produmex.Sbo.Logex.Data.ProdumexErrors.SerialNumberNotValidForPurchaseOrder(s_log, purchaseOrderDocEntry, (serialNumbers.Count == 1) ? serialNumbers[0] : "LIST", listOfErrors);
                    }

                    break;
                case Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxObjectTypes.PmxMoveOrder:
                case Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxObjectTypes.PmxMove:
					int? moveOrderDocEntry = null;
					if (DocEntry != null &&
						DocEntry.Get().HasValue)
					{
						moveOrderDocEntry = DocEntry.Get().Value;
					}

					listOfErrors = this.ExecuteMethodWithDbConnection<Collection<ProdumexError>>(out pmxError, false, false,
							 delegate(PmxDbConnection conn, object[] parameters)
							 {
								 PmxSerialNumberProvider serProv = new PmxSerialNumberProvider(conn);
								 return serProv.IsSerialNumberAllowed(ObjectType.Get(), DocEntry == null ? null : DocEntry.Get(), null, serialNumbers, ItriKey.Get(), true, pmxWarehouseCode, null, location, destinationLocationCode, moveOrderDocEntry, Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxObjectTypes.PmxMoveOrder, ItemInfo.Get().ItemCode, currentLUID, null, listOfLineNumbers, fullListOfSerialNumbersTemp, ref warningsTemp);
							 });

					if (listOfErrors != null)
					{
						pmxError = Produmex.Sbo.Logex.Data.ProdumexErrors.SerialNumberNotValidForMove(s_log, moveOrderDocEntry.HasValue ? moveOrderDocEntry.Value : 0,
							ObjectType.Get(), (serialNumbers.Count == 1) ? serialNumbers[0] : "LIST", listOfErrors);
					}

					break;
                case SboObjectTypes.InventoryTransferRequest:

                    int? wtrDocEntry = null;
                    if (DocEntry != null &&
                        DocEntry.Get().HasValue)
                    {
						wtrDocEntry = DocEntry.Get().Value;
                    }

                    listOfErrors = this.ExecuteMethodWithDbConnection<Collection<ProdumexError>>(out pmxError, false, false,
                             delegate(PmxDbConnection conn, object[] parameters)
                             {
                                 PmxSerialNumberProvider serProv = new PmxSerialNumberProvider(conn);
								 return serProv.IsSerialNumberAllowed(ObjectType.Get(), DocEntry == null ? null : DocEntry.Get(), null, serialNumbers, ItriKey.Get(), /*In stock is false when move from non managed by PMX whs*/!string.IsNullOrEmpty(pmxWarehouseCode), pmxWarehouseCode, null, location, destinationLocationCode, null, null, ItemInfo.Get().ItemCode, currentLUID, null, listOfLineNumbers, fullListOfSerialNumbersTemp, ref warningsTemp);
                             });

                    if (listOfErrors != null)
                    {
						pmxError = Produmex.Sbo.Logex.Data.ProdumexErrors.SerialNumberNotValidForMove(s_log, wtrDocEntry.HasValue ? wtrDocEntry.Value : 0,
							ObjectType.Get(), (serialNumbers.Count == 1) ? serialNumbers[0] : "LIST", listOfErrors);
                    }

                    break;
                case SboObjectTypes.SalesReturn:
                    //creates stock
                    listOfErrors = this.ExecuteMethodWithDbConnection<Collection<ProdumexError>>(out pmxError, false, false,
                             delegate(PmxDbConnection conn, object[] parameters)
                             {
                                 PmxSerialNumberProvider serProv = new PmxSerialNumberProvider(conn);
								 return serProv.IsSerialNumberAllowed(ObjectType.Get(), DocEntry == null ? null : DocEntry.Get(), null, serialNumbers, ItriKey.Get(), true, pmxWarehouseCode, null, location, destinationLocationCode, currentBaseEntry, currentBaseType, ItemInfo.Get().ItemCode, currentLUID, null, null, fullListOfSerialNumbersTemp, ref warningsTemp);
                                 //return serProv.IsSerialNumberAllowedGeneralChecks(ObjectType.Get(), DocEntry == null ? null : DocEntry.Get(), null, serialNumbers, ItriKey.Get(), true, pmxWarehouseCode, null, location, destinationLocationCode, ItemInfo.Get().ItemCode, null, true, null, null, currentLUID, null);
                             });

                    if (listOfErrors != null &&
                        listOfErrors.Count > 0)
                    {
                        pmxError = Produmex.Sbo.Logex.Data.ProdumexErrors.SerialNumberNotValid(s_log, ObjectType.Get(), (serialNumbers.Count == 1) ? serialNumbers[0] : "LIST", listOfErrors);
                    }
                    break;
                case SboObjectTypes.ProductionOrder:
                    //creates stock
                    listOfErrors = this.ExecuteMethodWithDbConnection<Collection<ProdumexError>>(out pmxError, false, false,
                             delegate(PmxDbConnection conn, object[] parameters)
                             {
                                 PmxSerialNumberProvider serProv = new PmxSerialNumberProvider(conn);
                                 return serProv.IsSerialNumberAllowedGeneralChecks(ObjectType.Get(), DocEntry == null ? null : DocEntry.Get(), null, serialNumbers, ItriKey.Get(), true, pmxWarehouseCode, null, location, destinationLocationCode, ItemInfo.Get().ItemCode, null, true, null, null, currentLUID, null, fullListOfSerialNumbersTemp, ref warningsTemp);
                             });

                    if (listOfErrors != null &&
                        listOfErrors.Count > 0)
                    {
                        pmxError = Produmex.Sbo.Logex.Data.ProdumexErrors.SerialNumberNotValid(s_log, ObjectType.Get(), (serialNumbers.Count == 1) ? serialNumbers[0] : "LIST", listOfErrors);
                    }
                    break;
                case Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxObjectTypes.PmxCycleCount:
                    // no check for cycle count: allow any serial number
                    break;
                default: 
                    listOfErrors = this.ExecuteMethodWithDbConnection<Collection<ProdumexError>>(out pmxError, false, false,
                             delegate(PmxDbConnection conn, object[] parameters)
                             {
                                 PmxSerialNumberProvider serProv = new PmxSerialNumberProvider(conn);
                                 return serProv.IsSerialNumberAllowedGeneralChecks(ObjectType.Get(), DocEntry == null ? null : DocEntry.Get(), null, serialNumbers, ItriKey.Get(), true, pmxWarehouseCode, null, location, destinationLocationCode, ItemInfo.Get().ItemCode, null, false, null, null, currentLUID, null, fullListOfSerialNumbersTemp, ref warningsTemp);
                             });

                    if (listOfErrors != null &&
                        listOfErrors.Count > 0)
                    {
                        pmxError = Produmex.Sbo.Logex.Data.ProdumexErrors.SerialNumberNotValid(s_log, ObjectType.Get(), (serialNumbers.Count == 1) ? serialNumbers[0] : "LIST", listOfErrors);
                    }

                    break;
            }

			warnings = warningsTemp;

            return pmxError;
        }

        private T ExecuteMethodWithDbConnection<T>(out ProdumexError pmxError, bool useSboConnection, bool useUserNameOfConnectionString, DelegateWithPmxDbConnection<T> methodDelegate, params object[] parameters)
        {
            T result = default(T);
            pmxError = null;

            try
            {
                result = m_sboProviderService.InvokeMethodWithDbConnection<T>(useSboConnection, useUserNameOfConnectionString, null, null,
                    methodDelegate, parameters);
            }
            catch (TargetInvocationException ex)
            {
                MethodInfo methodInfo = methodDelegate.Method;
                if (ex.InnerException is ProdumexException)
                {
                    s_log.Warn("Execute -- The invoked method threw a produmex exception: ", ex.InnerException);
                    pmxError = ((ProdumexException)ex.InnerException).Error;
                }
                else if (ex.InnerException == null)
                {
                    s_log.Warn("Execute -- The invoked method threw an exception: ", ex);
                    pmxError = Produmex.Foundation.Wwf.Sbo.ProdumexErrors.ExceptionInvokingSboMethod(s_log, methodInfo, ex.Message);
                }
                else
                {
                    s_log.Warn("Execute -- The invoked method threw a TargetInvocationException with inner exception: ", ex.InnerException);
                    pmxError = Produmex.Foundation.Wwf.Sbo.ProdumexErrors.ExceptionInvokingSboMethod(s_log, methodInfo, ex.InnerException.Message);
                }
            }
            catch (TransactionAbortedException ex)
            {
                MethodInfo methodInfo = methodDelegate.Method;
                pmxError = Produmex.Foundation.Wwf.Sbo.ProdumexErrors.ExceptionInvokingSboMethod(s_log, methodInfo, ex.InnerException == null ? ex.Message : ex.InnerException.Message);
            }
            catch (ProdumexException ex)
            {
                if (ex.Error != null)
                {
                    pmxError = ex.Error;
                }
                else
                {
                    MethodInfo methodInfo = methodDelegate.Method;
                    pmxError = Produmex.Foundation.Wwf.Sbo.ProdumexErrors.ExceptionInvokingSboMethod(s_log, methodInfo, ex.Message);
                }
            }
            catch (Exception ex)
            {
                s_log.Error("", ex);
                MethodInfo methodInfo = methodDelegate.Method;
                pmxError = Produmex.Foundation.Wwf.Sbo.ProdumexErrors.ExceptionInvokingSboMethod(s_log, methodInfo, ex.Message);
            }

            return result;
        }


        /// <summary>
        /// Gets the new Serial number data set.
        /// </summary>
        /// <returns></returns>
        private DataSet GetNewSerialNumberDataSet()
        {
            DataSet ds = new DataSet();
            ds.Tables.Add(SerialNumberDataSet.NAME);

            foreach (ColumnDefinition colDef in SerialNumberDataSet.Columns.ALL)
            {
                ds.Tables[0].Columns.Add(colDef.Name, colDef.Types[0]);
            }
           
            return ds;

        }


        /// <summary>
        /// Gets the new Serial number data set.
        /// </summary>
        /// <param name="listOfLinkedSerialNumbers">The list of linked serial numbers.</param>
        /// <param name="dsScannedSerialNumbers">The ds scanned serial numbers.</param>
        /// <returns></returns>
        private DataSet GetNewLinkedSerialNumberDataSet(Collection<SerialNumberInfo> listOfLinkedSerialNumbers, DataSet dsScannedSerialNumbers)
        {
            DataSet ds = GetNewSerialNumberDataSet();

            foreach (SerialNumberInfo serInfo in listOfLinkedSerialNumbers)
            {
                DataRow rowToAdd = ds.Tables[0].NewRow();
                rowToAdd[SerialNumberDataSet.Columns.SERIALNUMBER.Name] = serInfo.SerialNumber;
                rowToAdd[SerialNumberDataSet.Columns.INFO1.Name] = serInfo.Information1;
                rowToAdd[SerialNumberDataSet.Columns.INFO2.Name] = serInfo.Information2;


                if (this.GetNumberOfRows(dsScannedSerialNumbers) > 0)
                {
                    DataRow[] rows = dsScannedSerialNumbers.Tables[0].Select(string.Format("{0} = '{1}'", SerialNumberDataSet.Columns.SERIALNUMBER.Name, serInfo.SerialNumber));
                    rowToAdd[SerialNumberDataSet.Columns.IS_SCANNED.Name] = rows.Length > 0 ? SboBooleanColumnValues.Y.VALUE : SboBooleanColumnValues.N.VALUE;
                }
                else
                {
                    rowToAdd[SerialNumberDataSet.Columns.IS_SCANNED.Name] = SboBooleanColumnValues.N.VALUE;
                }

                ds.Tables[0].Rows.Add(rowToAdd);
            }



            return ds;

        }

 
        /// <summary>
        /// Gets the number of rows.
        /// </summary>
        /// <param name="ds">The ds.</param>
        /// <returns></returns>
        private int GetNumberOfRows(DataSet ds)
        {
            if (ds != null &&
                ds.Tables.Count > 0)
            {
                return ds.Tables[0].Rows.Count;
            }

            return 0;
        }


        /// <summary>
        /// Executes the get item info.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static PmxItemInfo ExecuteGetItemInfo(PmxDbConnection conn, object[] parameters)
        {
            PmxItemAllConnectionsProvider prov = new PmxItemAllConnectionsProvider(conn);
            return prov.GetCachedItemInfo((string)parameters[0]);
        }

        /// <summary>
        /// Executes the get transactional packaging types.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static Collection<PmxItemTransactionalPackagingType> ExecuteGetTransactionalPackagingTypes(PmxDbConnection conn, object[] parameters)
        {
            PmxItemTransactionalPackagingTypeProvider prov = new PmxItemTransactionalPackagingTypeProvider(conn);
            return prov.GetTransactionalPackagingTypes((int)parameters[0], (bool)parameters[1]);
        }


        /// <summary>
        /// Serials the number matches format.
        /// </summary>
        /// <param name="serialNumber">The serial number.</param>
        /// <param name="serialFormat">The serial format.</param>
        /// <returns></returns>
        private bool SerialNumberMatchesFormat(string serialNumber, string serialFormat)
        {

            return Regex.IsMatch(serialNumber, serialFormat);

        }


        #endregion

        #region BUILD QUERY

        /// <summary>
        /// Static class grouping our native queries
        /// </summary>
        internal static class BuildQuery
        {


            /// <summary>
            /// Gets the transactional packaging types.
            /// </summary>
            /// <param name="itriKey">The itri key.</param>
            /// <returns></returns>
            public static string GetTransactionalPackagingTypes(int itriKey)
            {
                StringBuilder strBuilder = new StringBuilder();
                strBuilder.Append("SELECT ");

                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalPackagingTypeTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalPackagingTypeTable.Columns.ItemTransactionalInfoKey.NAME));

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalPackagingTypeTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalPackagingTypeTable.Columns.PackagingTypeCode.NAME));

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalPackagingTypeTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalPackagingTypeTable.Columns.Quantity.NAME));

                strBuilder.Append(", ");
                strBuilder.Append( SqlCommandHelper.EscapeTableName( SboUomTable.NAME ) );
                strBuilder.Append(".");
                strBuilder.Append( SqlCommandHelper.EscapeColumnName( SboUomTable.Columns.UomName.NAME ) );

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemPackagingTypeTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemPackagingTypeTable.Columns.Barcode.NAME));


                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemPackagingTypeTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemPackagingTypeTable.Columns.HideDuringEnteringQuantity.NAME));


                strBuilder.Append(" FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalPackagingTypeTable.NAME));

                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
                strBuilder.Append(" ON ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalInfoTable.Columns.InternalKey.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalPackagingTypeTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalPackagingTypeTable.Columns.ItemTransactionalInfoKey.NAME));


                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemPackagingTypeTable.NAME));
                strBuilder.Append(" ON ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalPackagingTypeTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalPackagingTypeTable.Columns.PackagingTypeCode.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemPackagingTypeTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemPackagingTypeTable.Columns.PackagingTypeCode.NAME));

                strBuilder.Append(" AND ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemPackagingTypeTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemPackagingTypeTable.Columns.ItemCode.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalInfoTable.Columns.ItemCode.NAME));

                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append( SqlCommandHelper.EscapeTableName( SboUomTable.NAME ) );

                strBuilder.Append(" ON ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalPackagingTypeTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalPackagingTypeTable.Columns.PackagingTypeCode.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append( SqlCommandHelper.EscapeTableName( SboUomTable.NAME ) );
                strBuilder.Append(".");
                strBuilder.Append( SqlCommandHelper.EscapeColumnName( SboUomTable.Columns.UomCode.NAME ) );



                strBuilder.Append(" WHERE ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalPackagingTypeTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalPackagingTypeTable.Columns.ItemTransactionalInfoKey.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(itriKey, CultureInfo.InvariantCulture));

                strBuilder.Append(" ORDER BY ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalPackagingTypeTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalPackagingTypeTable.Columns.Quantity.NAME));
                strBuilder.Append(" DESC ");


                return strBuilder.ToString();
            }

 
        }

        #endregion

    }


}
